unit CapteurDlgU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils,Gauges, Grids, math,
  orphyLabUtil, orphyLabDef, orphyLabGraphe, orphyLabMainU, maths,
  etalon6V, orphyLabConst, ImgList, ComCtrls, aidekey;

type
  TCapteurDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    CancelBtn: TBitBtn;
    EtalonneBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    EditUnite: TEdit;
    ZeroBtn: TBitBtn;
    Label3: TLabel;
    EditComment: TEdit;
    Timer: TTimer;
    Gauge: TProgressBar;
    CapteursBtn: TBitBtn;
    AffichageGB: TGroupBox;
    CouleurCombo: TColorBox;
    EditMini: TLabeledEdit;
    EditMaxi: TLabeledEdit;
    PointCombo: TComboBoxEx;
    filtreCB: TCheckBox;
    EditValeur: TEdit;
    AideLabel: TLabel;
    FormatFixeCB: TCheckBox;
    NbreDecimaleSE: TSpinEdit;
    NbreDecimaleLabel: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure EtalonneBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure ZeroBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CancelBtnClick(Sender: TObject);
    procedure CapteursBtnClick(Sender: TObject);
    procedure FormatFixeCBClick(Sender: TObject);
  public
    modif : boolean;
  end;

var
  CapteurDlg: TCapteurDlg;

implementation

uses zeroU, lumicolorU, listeCapVolt, photocolorU;

{$R *.DFM}

procedure TCapteurDlg.FormActivate(Sender: TObject);
begin
    modif := false;
    with voieCapteur6V do begin
         EditNom.text := Nom;
         EditUnite.text := NomUnite;
         EditComment.text := Signif;
         CouleurCombo.selected := couleur;
         PointCombo.itemIndex := ord(motif);
         filtreCB.checked := filtrage50Hz;
         EditMini.text := FormatPortable(mini);
         EditMaxi.text := FormatPortable(maxi);
         aideLabel.caption := Aide;
         formatFixeCB.Checked := NbreDecimaleFixe>=0;
         NbreDecimaleSE.value := NbreDecimaleFixe;
         NbreDecimaleSE.Visible := FormatFixeCB.checked;
         NbreDecimaleLabel.visible := FormatFixeCB.checked;
    end;
    Timer.enabled := orphyLabMain.orphyPresent;
    EtalonneBtn.caption := trEtaloni;
end;

procedure TCapteurDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TCapteurDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TCapteurDlg.TimerTimer(Sender: TObject);
var valeur : word;
begin with voieCapteur6V do begin
     try
     valeur := OrphyLabMain.getWord(ZEA);
     Gauge.position := valeur;
     valeurAff := valeurReal(valeur);
     EditValeur.text := affVoltmetre+' '+nomUniteAff;
     except
         Gauge.position := 0
     end;
end end;

procedure TCapteurDlg.OKBtnClick(Sender: TObject);
var min,max : double;
begin
     timer.enabled := false;
     with voieCapteur6V do begin
          active := true;
          Nom := EditNom.text;
          NomUnite := EditUnite.text;
          Signif := EditComment.text;
          max := strToFloatWin(EditMaxi.text);
          if isNan(max) then max := 10;
          min := StrToFloatWin(EditMini.text);
          if isNan(min) then min := -10;
          setMinMax(min,max);
          Couleur := CouleurCombo.selected;
          Motif := Tmotif(PointCombo.itemIndex);
          filtrage50Hz := filtreCB.checked;
          if FormatFixeCB.checked
            then NbreDecimaleFixe := NbreDecimaleSE.value
            else NbreDecimaleFixe := -1;
          calculMinMax;
    end;
end;

procedure TCapteurDlg.EtalonneBtnClick(Sender: TObject);
begin with voieCapteur6V do begin
    timer.enabled := false;
    Nom := EditNom.text;
    NomUnite := EditUnite.text;
    if Etalonne6VDlg=nil then
       application.createForm(TEtalonne6VDlg,Etalonne6VDlg);
    Etalonne6VDlg.voieCourante := voieCapteur;
    if Etalonne6VDlg.showModal=mrOK then
       isLumicolor := false;
    modif := true;
    timer.enabled := true;
end end;

procedure TCapteurDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Configuration)
end;

procedure TCapteurDlg.CancelBtnClick(Sender: TObject);
begin
    timer.enabled := false;
    voieCapteur6V.active := false
end;

procedure TCapteurDlg.CapteursBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     if ListeCapteursVoltDlg=nil then
        Application.CreateForm(TListeCapteursVoltDlg, ListeCapteursVoltDlg);
     ListeCapteursVoltDlg.voieCourante := voieCapteur;
     if ListeCapteursVoltDlg.showModal=mrOK then begin
        FormActivate(nil);
        modif := true;
     end;
     timer.enabled := true;
end;

procedure TCapteurDlg.FormatFixeCBClick(Sender: TObject);
begin
  NbreDecimaleSE.Visible := FormatFixeCB.checked;
  NbreDecimaleLabel.visible := FormatFixeCB.checked;
end;

procedure TCapteurDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
    if not caracNom(key) then key := #0
end;

procedure TCapteurDlg.ZeroBtnClick(Sender: TObject);

procedure Lumicolor;
begin
   if LumicolorDlg=nil then
        Application.CreateForm(TLumicolorDlg, LumicolorDlg);
   voieCapteur6V.isLumicolor := LumicolorDlg.showModal=mrOK;
   modif := true;
   voieCapteur6V.nomUnite := '';
   editUnite.text := '';
   voieCapteur6V.setMinMax(0,3);
end;

procedure Photocolor;
begin
   if PhotocolorDlg=nil then
        Application.CreateForm(TPhotocolorDlg, PhotocolorDlg);
   voieCapteur6V.isPhotocolor := PhotocolorDlg.showModal=mrOK;
   modif := true;
   voieCapteur6V.nomUnite := '';
   editUnite.text := '';
   voieCapteur6V.setMinMax(0,3);
end;

procedure autres;
begin
   if ZeroDlg=nil then application.createForm(TZeroDlg,ZeroDlg);
   ZeroDlg.voie := voieCapteur;
   ZeroDlg.showModal
end;

begin
   timer.enabled := false;
   if  voieCapteur6V.isLumicolor
       then Lumicolor
       else if  voieCapteur6V.isPhotocolor
           then photocolor
           else autres;
   timer.enabled := true;
end;

end.

