unit ChoixcapteursU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  system.UITypes,
  StdCtrls, ExtCtrls, Dialogs, SysUtils, orphyLabConst,
  orphyLabdef, orphyLabGraphe, orphyLabUtil, capteurCfgU;

type
  TChoixCapteursDlg = class(TForm)
    ListeCapteursBox: TListBox;
    EnregistreBtn: TBitBtn;
    AddBtn: TBitBtn;
    DelBtn: TBitBtn;
    ModifBtn: TBitBtn;
    ExitBtn: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
    procedure ModifBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
  private
    Modif : boolean;
    procedure MajListe;
  public
  end;

var
  ChoixCapteursDlg: TChoixCapteursDlg;

implementation

{$R *.DFM}

procedure TChoixCapteursDlg.FormActivate(Sender: TObject);
var i : byte;
begin
     if capteurCfgDlg=nil then
        Application.CreateForm(TCapteurCfgDlg, CapteurCfgDlg);
     with ListeCapteursBox.Items do begin
        Clear;
        for i := 0 to pred(listeCapteur.count) do
            Add(ListeCapteur.items[i].nomC);
        ListeCapteursBox.itemIndex := 0;
        Modif := false;
     end;
end;

procedure TChoixCapteursDlg.EnregistreBtnClick(Sender: TObject);
begin
     SauveListeCapteurs;
     Modif := false;
end;

procedure TChoixCapteursDlg.AddBtnClick(Sender: TObject);
var capteur : TCapteur;
begin
    capteur := Tcapteur.create;
    CapteurCfgDlg.capteurCourant := capteur;
    if CapteurCfgDlg.ShowModal=mrOK
       then begin
          listeCapteur.add(capteur);
          MajListe;
       end
       else capteur.free
end;

procedure TChoixCapteursDlg.DelBtnClick(Sender: TObject);
begin
     if  MessageDlg(format(trDelCapteur,
        [ListeCapteur.items[ListeCapteursBox.itemIndex].nomC]),
        mtConfirmation,[mbYes,mbNo],0)=idYes then begin
        ListeCapteur.remove(listeCapteur.items[listeCapteursBox.itemIndex]);
        MajListe;
     end;
end;

procedure TChoixCapteursDlg.ModifBtnClick(Sender: TObject);
begin
     capteurCfgDlg.capteurCourant := listeCapteur.items[listeCapteursBox.itemIndex];
     if capteurCfgDlg.showModal=mrOk then MajListe;
end;

procedure TChoixCapteursDlg.ExitBtnClick(Sender: TObject);
begin
     if Modif and OKreg(trSaveModif) then EnregistreBtnClick(sender);
     Close
end;

Procedure TChoixCapteursDlg.MajListe;
var i : integer;
begin
     DelBtn.visible := listeCapteur.count>1;
     ListeCapteursBox.clear;
     for i:=0 to pred(listeCapteur.count) do
         ListeCapteursBox.items.Add(ListeCapteur.items[i].nomC);
     ListeCapteursBox.itemIndex := 0;
     Modif := true;
end;

end.
