unit Etalon;

interface

uses Windows, Classes, Graphics, Forms, Buttons,
  StdCtrls, ExtCtrls, Gauges, Sysutils,
  maths, orphyLabUtil, orphyLabDef, orphyLabMainU,
  orphyLabConst, orphyLabGraphe, math, aidekey, Controls;

type
  TEtalonneInterDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    EditInteractif1: TEdit;
    EditInteractif2: TEdit;
    GaugeInter2: TGauge;
    GaugeInter1: TGauge;
    Bevel3: TBevel;
    Timer: TTimer;
    Point1: TSpeedButton;
    Point2: TSpeedButton;
    Point2Manuel: TSpeedButton;
    Label2: TLabel;
    EditSignif: TEdit;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Point1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure Point2Click(Sender: TObject);
    procedure Point2ManuelClick(Sender: TObject);
    procedure EditInteractif2KeyPress(Sender: TObject; var Key: Char);
    procedure EditInteractif1KeyPress(Sender: TObject; var Key: Char);
  private
    point1Actif : boolean;
    valeurReel : array[1..2] of double;
    valeurCan : array[1..2] of integer;
    procedure Validation;
  public
    voieCourante : IndiceVoie;
  end;

var
  EtalonneInterDlg: TEtalonneInterDlg;

implementation

{$R *.DFM}

procedure TEtalonneInterDlg.TimerTimer(Sender: TObject);
var zw : word;
begin with OrphyLabMain do begin
     zw := getWord(graphe.voieOrphy[voieCourante].ZEA);
     if point1Actif
         then GaugeInter1.progress := zw
         else GaugeInter2.progress := zw
end end;

procedure TEtalonneInterDlg.FormActivate(Sender: TObject);
begin with graphe.voieOrphy[voieCourante] do begin
     if voieCourante=voieCapteur then begin
         EditInteractif1.text := FormatPortable(0);
         EditInteractif2.text := FormatPortable(1);
     end
     else with Capsule do begin
        EditInteractif1.text := FormatPortable(valeur0);
        EditInteractif2.text := FormatPortable(valeur1024);
     end;
     GaugeInter1.progress := 0;
     GaugeInter2.progress := MaxiHard;
     Caption := Nom+'/'+NomUnite;
     Point1.down := false;
     Point2.down := false;
     Point1Actif := true;
     timer.enabled := true;
     Point1.visible := true;
     Point2.visible := false;
     EditInteractif1.setFocus;
end end;

procedure TEtalonneInterDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TEtalonneInterDlg.Point1Click(Sender: TObject);
begin
   point1Actif := false;
   EditInteractif2.setFocus;
   Point1.visible := false;
   Point2.visible := true;
end;

procedure TEtalonneInterDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TEtalonneInterDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_Etalonnage)
end;

procedure TEtalonneInterDlg.Point2Click(Sender: TObject);
begin
     valeurReel[1] := StrToFloatWin(EditInteractif1.text);
     valeurCan[1] := GaugeInter1.progress;
     valeurReel[2] := StrToFloatWin(EditInteractif2.text);
     valeurCan[2] := GaugeInter2.progress;
     if isNan(valeurReel[1]) or
        isNan(valeurReel[2])
          then begin
             afficheErreur(erEtalon);
             modalResult := mrNone;
          end
          else validation;
end;

procedure TEtalonneInterDlg.Validation;
var pente : double;
    val0,val1024 : double;
begin
     if abs(valeurCan[2]-valeurCan[1])>MaxiHard div 64
     then with graphe.voieOrphy[voieCourante] do begin
            pente := (valeurReel[2]-valeurReel[1])/(valeurCan[2]-valeurCan[1]);
            val0 := valeurReel[2]-pente*valeurCan[2];
            val1024 := val0+pente*MaxiHard;
            graphe.voieOrphy[voieCourante].setMinMax(val0,val1024);
            if positif then mini := 0;
            graphe.voieOrphy[voieCourante].EtalonnageFait := true;
            graphe.voieOrphy[voieCourante].signif := EditSignif.text;
            modalResult := mrOK;
     end
     else begin
           afficheErreur(erEtalon2);
           modalResult := mrNone;
     end;
end;

procedure TEtalonneInterDlg.Point2ManuelClick(Sender: TObject);
begin
     valeurReel[2] := 0;
     valeurCan[1] := GaugeInter1.progress;
     valeurReel[1] := StrToFloatWin(EditInteractif1.text);
     if isNan(valeurReel[1])
        then begin
           afficheErreur(erEtalon);
           modalResult := mrNone;
        end
        else begin
           if (voieCourante=voieCapteur) or
              (graphe.voieOrphy[voieCourante].Capsule.capteurPosNeg)
// capteurs symtriques +- xxx V
                 then valeurCan[2] := MaxiHard div 2 else valeurCan[2] := 0;
            validation;
        end;
end;

procedure TEtalonneInterDlg.EditInteractif2KeyPress(Sender: TObject;
  var Key: Char);
begin
     if key=crCR then Point2Click(sender);
end;

procedure TEtalonneInterDlg.EditInteractif1KeyPress(Sender: TObject;
  var Key: Char);
begin
     if key=crCR then Point1Click(sender);
end;

end.
