unit ETALON6V;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils, ComCtrls, math,
  maths, orphyLabUtil, orphyLabDef, orphyLabGraphe, orphyLabMainU,
  orphyLabConst, aidekey;

type
  TEtalonne6VDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    EditInteractif1: TEdit;
    EditInteractif2: TEdit;
    Label4: TLabel;
    Bevel3: TBevel;
    Timer: TTimer;
    Point1: TSpeedButton;
    Point2: TSpeedButton;
    Point2Manuel: TSpeedButton;
    GaugeInter1: TProgressBar;
    GaugeInter2: TProgressBar;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Point1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure Point2Click(Sender: TObject);
    procedure Point2ManuelClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    point1Actif : boolean;
    procedure finOK(Manuel : boolean);
  public
    voieCourante : indiceVoie;
  end;

var
  Etalonne6VDlg: TEtalonne6VDlg;

implementation

{$R *.DFM}

procedure TEtalonne6VDlg.TimerTimer(Sender: TObject);
var zw : word;
begin
     zw := orphyLabMain.getWord(graphe.voieOrphy[voieCourante].ZEA);
     if point1Actif
        then GaugeInter1.position := zw
        else GaugeInter2.position := zw
end;

procedure TEtalonne6VDlg.FormActivate(Sender: TObject);
begin with graphe.voieOrphy[voieCourante] do begin
     timer.interval := 500;
     EditInteractif1.text := FormatPortable(0);
     EditInteractif2.text := FormatPortable(0);
     GaugeInter1.position := 2048;
     GaugeInter2.position := 2048;
     LabelInteractif.caption := Nom+'/'+NomUnite;
     Point1.down := false;
     Point2.down := false;
     Point1Actif := true;
     timer.enabled := true;
     Point1.visible := true;
     Point2.visible := false;
     Point2Manuel.visible := false;
     EditInteractif1.setFocus;
end end;

procedure TEtalonne6VDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TEtalonne6VDlg.finOK(Manuel : boolean);
var valeurReel,valeurCan : array[1..2] of double;
    valeurOK : boolean;
    pente : double;
    val0,val1024 : double;
begin with graphe.voieOrphy[voieCourante] do begin
     timer.enabled := false;
     try
     valeurReel[1] := StrToFloatWin(EditInteractif1.text);
     valeurCan[1] := GaugeInter1.position;
     if manuel
        then begin
             valeurReel[2] := 0;
             valeurCan[2] := 0;
        end
        else begin
             valeurReel[2] := StrToFloatWin(EditInteractif2.text);
             valeurCan[2] := GaugeInter2.position;
        end;
     ValeurOK := not (
                 isNan(valeurReel[1]) or
                 isNan(valeurReel[2])) and
                 (valeurReel[2]<>valeurReel[1]);
     if not valeurOK then raise Exception.create(erEtalon);
     valeurOK := abs(valeurCan[2]-valeurCan[1]) > MaxiHard/64;
     if valeurOK
        then begin
            pente := (valeurReel[2]-valeurReel[1])/(valeurCan[2]-valeurCan[1]);
            val0 := valeurReel[2]-pente*valeurCan[2];
            val1024 := val0+pente*MaxiHard;
            setMinMax(val0,val1024);
        end
        else raise Exception.create(erEtalon2);
     modalResult := mrOK;
     except
        on E: Exception do begin
           afficheErreur(E.message);
           modalResult := mrNone;
           timer.enabled := true;
        end;
     end;
end end;

procedure TEtalonne6VDlg.Point1Click(Sender: TObject);
begin
   point1Actif := false;
   EditInteractif2.setFocus;
   Point1.visible := false;
   Point2.visible := true;
   Point2Manuel.visible := true;
end;

procedure TEtalonne6VDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TEtalonne6VDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Etalonnage)
end;

procedure TEtalonne6VDlg.Point2Click(Sender: TObject);
begin
     finOK(false)
end;

procedure TEtalonne6VDlg.Point2ManuelClick(Sender: TObject);
begin
     finOK(true)
end;

procedure TEtalonne6VDlg.CancelBtnClick(Sender: TObject);
begin
    timer.enabled := false;
    close;
end;

end.
