unit MagnumDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, orphyLabUtil, Spin, ComCtrls;

type
  TMagnumCfg = class(TForm)
    Label4: TLabel;
    TailleTraitEdit: TEdit;
    Label7: TLabel;
    UniteEdit: TEdit;
    OKBtn: TBitBtn;
    BitBtn2: TBitBtn;
    DefautBtn: TBitBtn;
    NomEdit: TEdit;
    Label1: TLabel;
    Timer: TTimer;
    PositionLabel: TLabel;
    NegatifCB: TCheckBox;
    ArretGB: TGroupBox;
    Label2: TLabel;
    DureeSE: TSpinEdit;
    DureeMaxCB: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DefautBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TailleTraitEditKeyPress(Sender: TObject; var Key: Char);
    procedure TailleTraitEditExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DureeMaxCBClick(Sender: TObject);
  private
  public
  end;

var
  MagnumCfg: TMagnumCfg;

implementation

uses orphyLabConst, orphyLabDef, orphyLabMainU;

{$R *.DFM}

procedure TMagnumCfg.OKBtnClick(Sender: TObject);
begin
    PeriodeMagnumE := StrToFloatWin(TailleTraitEdit.text);
    uniteMagnum := UniteEdit.text;
    nomMagnum := NomEdit.text;
    magnumChuteNegatif := negatifCB.checked;
    if DureeMaxCB.checked
       then DureeMaxMagnum := DureeSE.value
       else DureeMaxMagnum := 0;
end;

procedure TMagnumCfg.DureeMaxCBClick(Sender: TObject);
begin
	DureeSE.visible := DureeMaxCB.checked;
end;

procedure TMagnumCfg.FormActivate(Sender: TObject);
begin
  inherited;
    TailleTraitEdit.text := formatPortable(PeriodeMagnumE);
    UniteEdit.text := UniteMagnum;
    negatifCB.checked := magnumChuteNegatif;
    DureeSE.value := DureeMaxMagnum;
    DureeSE.visible := DureeMaxMagnum>0;
    NomEdit.text := NomMagnum;
    OrphyLabMain.EcritOrphy(ZRazPosition);
    sleep(10);
    OrphyLabMain.EcritOrphy(ZStartPosition);
    Timer.enabled := true;
end;

procedure TMagnumCfg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    OrphyLabMain.ecritOrphy(ZStopPosition);
    Timer.enabled := false;
end;

procedure TMagnumCfg.DefautBtnClick(Sender: TObject);
begin
    PeriodeMagnumE := PeriodeMagnum;
    uniteMagnum := 'm';
    nomMagnum := 'z';
    FormActivate(sender);
end;

procedure TMagnumCfg.TailleTraitEditExit(Sender: TObject);
begin
    PeriodeMagnumE := StrToFloatWin(TailleTraitEdit.text);
    uniteMagnum := UniteEdit.text;
    nomMagnum := NomEdit.text;
end;

procedure TMagnumCfg.TailleTraitEditKeyPress(Sender: TObject; var Key: Char);
begin
   if key = crCR then TailleTraitEditExit(sender)
end;

procedure TMagnumCfg.TimerTimer(Sender: TObject);
var z : word;
begin with OrphyLabMain do begin
    z := getWord(Zposition);
    if (z>16) and (z<2*zeroMagnum) then
    PositionLabel.caption := NomEdit.text+'='+
       FormatPortable((z-zeroMagnum)*PeriodeMagnumE)+
       ' '+uniteEdit.text
       else PositionLabel.caption := ''
end end;

procedure TMagnumCfg.FormDeactivate(Sender: TObject);
begin
    OrphyLabMain.ecritOrphy(ZStopPosition);
    Timer.enabled := false;
end;

end.

