unit OneInst;

interface

procedure EnsureSingleInstance;

implementation

uses
  Windows, Forms, SysUtils, Messages, clipbrd, OrphyLabUtil;

procedure EnsureSingleInstance;
var
  Wnd,FormMainWnd: HWnd;
  WndClass, WndText: array[0..512] of char;
  NomFichier : String;
  i : integer;
begin
 { Try and create a semaphore. If we succeed, then check }
  { if the semaphore was already present. If it was }
  { then a previous instance is floating around. }
  { Note the OS will free the returned semaphore handle }
  { when the app shuts so we can forget about it }
  if (CreateSemaphore(nil, 0, 1,'OrphyLab') <> 0) and
     (GetLastError = Error_Already_Exists) then begin
    Wnd := GetWindow(Application.Handle, gw_HWndFirst);
    FormMainWnd := 0;
    while Wnd <> 0 do begin
      { Look for the other TApplication window out there }
      if Wnd <> Application.Handle then begin
        { Check it's definitely got the same class and caption }
        GetClassName(Wnd, WndClass, Pred(SizeOf(WndClass)));
        GetWindowText(Wnd, WndText, Succ(Length(Application.Title)));
        if (StrPas(WndClass) = 'TOrphyLabMain') then FormMainWnd := Wnd;
        if (StrPas(WndClass) = Application.ClassName) and
           (StrPas(WndText) = Application.Title) then begin
          { This technique is used by the VCL: post }
          { a message then bring the window to the }
          { top, before the message gets processed }
          PostMessage(Wnd, wm_SysCommand, sc_Restore, 0);
          SetForegroundWindow(Wnd);
          if paramCount>0 then begin
             NomFichier := ParamStr(1);
             for i := 2 to paramCount do
             NomFichier := NomFichier+' '+ParamStr(i);
             ClipBoard.AsText := NomFichier;
             if FormMainWnd=0
                then PostMessage(Wnd, wm_File_Load, 0, 0)
                else PostMessage(FormMainWnd, wm_File_Load, 0, 0);
          end;
          Halt
        end
      end;
      Wnd := GetWindow(Wnd, gw_HWndNext)
    end
  end
end;

end.
