unit OrphyLabDDEU;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, math, controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, registry, clipbrd, ComCtrls,
  oomisc, Maths, orphyLabGraphe, uniteker, orphyLabUtil, orphyLabDef, shellApi;

type
  Tenvoi = (eAdd,eLoad,ePlus,eFileLoad);
  TOrphyLabDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
      procedure Execute(Ordre : Tenvoi;argument : string);
  public
      procedure EnvoieFichier;
      procedure EnvoieDonnees(DDE : boolean;nomFichier : String);
      procedure AjouteDonnees(debut,fin : integer);
  end;

var
  OrphyLabDDE: TOrphyLabDDE;

implementation

uses orphyLabMainU, orphyLabConst, orphyLabReg;

const crTab=#9;

{$R *.DFM}

procedure TOrphyLabDDE.Execute(Ordre : Tenvoi;argument : string);

Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication), nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
var ordreStr : ansiString;
begin
    case ordre of
         eAdd : ordreStr := 'CLIP|ADD';
         eLoad : ordreStr := 'CLIP|LOAD';
         ePlus : ordreStr := 'CLIP|PLUS';
         eFileLoad : ordreStr := 'FILE|LOAD('+ansiString(argument)+')';
    end;
    if not ClientDDE.ExecuteMacro(PAnsiChar(ordreStr), false) then
       ShowMessage('Transfert non excut');
    ClientDDE.CloseLink;
end;

begin
     lanceRegressi;
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then lance
        else begin
             sleep(1000);
          // OpenLik = false efface
             ClientDDE.SetLink('Regressi','ServeurDDE');
             ClientItem.DDEItem := 'ServeurItem';
             if ClientDDE.OpenLink
                then lance
                else ShowMessage('Impossible de lancer Regressi');
        end;
end;

procedure TOrphyLabDDE.FormCreate(Sender: TObject);
var Ini : TRegIniFile;
    Registre : Tregistry;
    reponse : string;
begin
    Ini := TRegIniFile.create('Software\Regressi');
    Reponse := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    if reponse='' then begin
      Ini := TRegIniFile.create('Software');
      Reponse := Ini.ReadString('Regressi','Path','');
      Ini.Free;
    end;
    if reponse='' then begin
      Registre := TRegistry.create;
      Registre.RootKey := HKEY_CLASSES_ROOT;
      if Registre.OpenKey('rw3File\Shell\Open\Command',false) then
         reponse := Registre.ReadString(''); // '' donc default
      Registre.Free;
    end;
    if reponse='' then reponse := 'regressi.exe';
    ClientDDE.ServiceApplication := Reponse;
end;

procedure TOrphyLabDDE.EnvoieDonnees(DDE : boolean;nomFichier : String);
var ligne : string;
    ligneOK : boolean;
    donnees : TstringList;
    repere : Trepere;

procedure AjouteConst;
begin with ConstanteDlg do begin
     if (nomConstante='') or isNan(valeurConstante) then exit;
     donnees.Add('');
     donnees.Add(nomConstante);
     donnees.Add(uniteConstante);
     donnees.Add(FloatToStrPoint(valeurConstante));
end end;

Procedure AjouteOptionsGr;
var i : integer;
    v : indiceVoie;
    n : integer;
begin with graphe do begin
     n := 0;
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if Yvisible then inc(n);
     with voieCalculee do
         if Yvisible then inc(n);
     donnees.Add(symbReg2+intToStr(n)+' NOMX');
     for i := 1 to n do
         donnees.Add(voieOrphy[voieAbscisse].nom);
     donnees.Add(symbReg2+intToStr(n)+' NOMY');
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if Yvisible then donnees.Add(nom);
     with voieCalculee do
         if Yvisible then donnees.Add(nom);
     if analyseurLogique then begin
         donnees.Add(symbReg2+'1 AnalLogique');
         donnees.Add(IntToStr(ord(true)));
     end;
     donnees.Add(symbReg2+'1 DIMPOINT');
     donnees.Add(IntToStr(dimPoint));
     donnees.Add(symbReg2+'1 GRILLE');
     donnees.Add(IntToStr(ord(Quadrillage)));
     donnees.Add(symbReg2+intToStr(n)+' COULEUR');
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if Yvisible then
             donnees.Add(IntToStr(couleur));
     with voieCalculee do
         if Yvisible then donnees.Add(IntToStr(couleur));
     donnees.Add(symbReg2+intToStr(n)+' MOTIF');
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if Yvisible then
            donnees.Add(IntToStr(ord(motif)));
     with voieCalculee do
          if Yvisible then donnees.Add(IntToStr(ord(motif)));
     donnees.Add(symbReg2+intToStr(n)+' LIGNE');
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if Yvisible then
            if traceLigne
               then donnees.Add('2')
               else donnees.Add('1');
     with voieCalculee do
         if Yvisible then if traceLigne
               then if traceMotif
                    then donnees.Add('3')
                    else donnees.Add('2')
               else donnees.Add('1');
end end;

Procedure SansNum;
var v : indiceVoie;
    i : indiceVecteur;

Function AddPoint(v : indiceVoie) : string;
begin
   result := '';
   with graphe.voieOrphy[v] do
       if isNan(vecteurAff[i])
          then ligneOK := false
          else result := FloatToStrPoint(vecteurAff[i]) + crTab
end;

begin with graphe do begin
     ligne := '';
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then
            ligne := ligne + nom + crTab;
     with voieCalculee do
         if active then ligne := ligne + nom + crTab;
     donnees.Add(ligne);
     ligne := '';
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then
            ligne := ligne + nomUnite + crTab;
     with voieCalculee do
         if active then ligne := ligne + nomUnite + crTab;
     donnees.Add(ligne);
     ligne := '';
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then
            ligne := ligne + signif + crTab;
     with voieCalculee do
         if active then ligne := ligne + signif + crTab;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligneOK := true;
         ligne := '';
         for v := voie0 to voieAnaMax do
             if voieOrphy[v].active then
                ligne := ligne + AddPoint(v);
         with voieCalculee do
             if active then ligne := ligne + AddPoint(voieCalc);
         if ligneOK then donnees.Add(ligne);
     end; // for i
end end;

Procedure AvecNum;
var i : indiceVecteur;
    v,v1 : indiceVoie;

Function AddPoint(v : indiceVoie) : string;
begin
   result := '';
   with graphe.voieOrphy[v] do
       if isNan(vecteurAff[i])
          then ligneOK := false
          else begin
             try
             result := FloatToStrPoint(vecteurAff[i])
             except
                ligneOK := false
             end;
          end;
end;

begin with graphe do begin
     v1 := voieT;
     case modeAcq of
          AcqTemps : ;
          AcqPoint : for i := 0 to maxVecteur do
              voieOrphy[voieT].vecteurAff[i] := i;
          AcqClavier : v1 := voieClavier;
     end;
     if (modeAcq=AcqPoint)
        then Ligne := 'num'
        else ligne := voieOrphy[v1].nom;
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then
            ligne := ligne + crTab + nom;
     with voieCalculee do
         if active then ligne := ligne + crTab + nom;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint)
        then Ligne := ''
        else ligne := voieOrphy[v1].nomUnite;
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + crTab + nomUnite;
     with voieCalculee do
         if active then ligne := ligne + crTab + nomUnite;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint)
        then Ligne := ''
        else ligne := voieOrphy[v1].signif;
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + crTab + signif;
     with voieCalculee do
         if active then ligne := ligne + crTab + signif;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligneOK := true;
         ligne := AddPoint(v1);
         for v := voie0 to voieAnaMax do
             if voieOrphy[v].active and (v<>v1) then
                ligne := ligne + crTab + AddPoint(v);
         with voieCalculee do if active then
             ligne := ligne + crTab + AddPoint(voieCalc);
         if ligneOK then donnees.Add(ligne);
     end; // for i
end end;

var v,vv : indiceVoie;
    i : integer;
begin with graphe do begin // EnvoieDonnees
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     if DDE then begin
        donnees.Add(Application.exeName);
        if ConstanteDlg.NewPageCB.itemIndex=1
           then donnees.Add('')
           else donnees.Add('Acquisition par OrphyLab');
        donnees.Add(ConstanteDlg.editComm.text);
     end;
// vrification des noms et des doublons
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then begin
            if nom='' then if (capsule<>nil) and capsule.useEF0
               then nom := 'f'
               else nom := 'U';
            if not charInSet(nom[1],majuscule+minuscule) and
              (pos(nom[1],grecque)=0) then
               if (capsule<>nil) and capsule.useEF0
                  then nom := 'f'+nom
                  else nom := 'U'+nom;
         end;
     with voieCalculee do if active then begin
          if nom=''
             then nom := 'capteur'
             else if not charInSet(nom[1],majuscule+minuscule) and
                    (pos(nom[1],grecque)=0) then nom := 'C'+nom;
     end;
     for v := voie0 to voieAnaMax do
         if voieOrphy[v].active then
            for vv := succ(v) to voieAnaMax do
                if voieOrphy[vv].active and
                   (voieOrphy[vv].nom=voieOrphy[v].nom) then begin
                      voieOrphy[v].nom := voieOrphy[v].nom+intToStr(v);
                      voieOrphy[vv].nom := voieOrphy[vv].nom+intToStr(vv);
                end;
     if voieCalculee.active then
     for vv := voie0 to voieAnaMax do
            if voieOrphy[vv].active and
              (voieOrphy[vv].nom=voieCalculee.nom) then begin
                   voieCalculee.nom := voieCalculee.nom+'c';
                   voieOrphy[vv].nom := voieOrphy[vv].nom+intToStr(vv);
            end;
     try
     if (modeAcq<>AcqPoint) or OrphyLabMain.sauveNum
        then avecNum
        else sansNum;
     AjouteConst;
     if DDE and (ConstanteDlg.NewPageCB.itemIndex=0) then AjouteOptionsGr;
     except
     end;
     if nomFichier<>''
        then donnees.saveToFile(NomFichier)
        else begin
           ClipBoard.clear;
           if ListeRepere.count>0 then begin
              donnees.Add(symbReg2+IntToStr(ListeRepere.count)+' REPERE');
              for i := 0 to pred(ListeRepere.count) do begin
                 repere := listeRepere[i];
                 donnees.Add(FloatToStrPoint(repere.valeur)+crTab+repere.edit.text);
              end;
           end;
           ClipBoard.asText := Donnees.text;
           if DDE then if ConstanteDlg.NewPageCB.itemIndex=1
              then begin
                 Execute(eADD,'');
              end
              else begin
                 Execute(eLOAD,'');
              end;
        end;
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Screen.Cursor := crDefault;
     donnees.free;
end end; // EnvoieDonnees

procedure TOrphyLabDDE.EnvoieFichier;
var
    fichier : textFile;
    nomFichier : String;
    avecNum : boolean;
    v1 : integer;
    repere : Trepere;

procedure ecritChaineRW3(s : string);
var sRW3 : shortString;

Procedure UnicodeVersRW3;
var i : integer;
    carac : char;
    caracR : AnsiChar;
begin
     sRW3 := '';
     for i := 1 to length(s) do begin
         carac := s[i];
         if (pos(carac,grecque)>0) or
            charInSet(carac,lettreAccent)
            then case carac of
                      alpha : caracR := alphaR;
                      beta : caracR := betaR;
                      gamma: caracR := gammaR;
                      gammaMaj: caracR := gammaMajR;
                      delta: caracR := deltaR;
                      deltaMaj: caracR := deltaMajR;
                      epsilon: caracR := epsilonR;
                      zeta: caracR := zetaR;
                      eta: caracR := etaR;
                      kappa: caracR := 'k';
                      lambda: caracR := lambdaR;
                      lambdaMaj: caracR := lambdaMajR;
                      mu: caracR := muR;
                      nu: caracR := nuR;
                      xi: caracR := xiR;
                      xiMaj: caracR := xiMajR;
                      pimin: caracR := piR;
                      piMaj: caracR := piMajR;
                      rho: caracR := rhoR;
                      sigma: caracR := sigmaR;
                      sigmaMaj: caracR := sigmaMajR;
                      tau: caracR := tauR;
                      theta: caracR := thetaR;
                      thetaMaj: caracR := thetaMajR;
                      phi: caracR := phiR;
                      phiMaj: caracR := phiMajR;
                      chi: caracR := chiR;
                      psi: caracR := psiR;
                      psiMaj: caracR := psiMajR;
                      omega: caracR := omegaR;
                      omegaMaj: caracR := omegaMajR;
                      '' : caracR := AnsiChar(233);
                      '' : caracR := AnsiChar(232);
                      '' : caracR := AnsiChar(234);
                      '' : caracR := AnsiChar(235);
                      '' : caracR := AnsiChar(239);
                      '' : caracR := AnsiChar(224);
                      '' : caracR := AnsiChar(226);
                      '' : caracR := AnsiChar(249);
                      '' : caracR := AnsiChar(251);
                      '' : caracR := AnsiChar(252);
                      '' : caracR := AnsiChar(252);
                      else caracR := '?';
                 end
            else caracR := AnsiChar(carac);
            sRW3 := sRW3+caracR;
     end;
end;

begin
    UnicodeVersRW3;
    writeln(fichier,sRW3);
end;

procedure writeNombreWin(const z : double);
var nombre : string;
    posSeparator : integer;
begin
     nombre := FloatToStrF(z,ffGeneral,7,2);
     if FormatSettings.decimalSeparator<>'.' then begin
        posSeparator := pos(FormatSettings.decimalSeparator,nombre);
        if posSeparator>0 then Nombre[posSeparator] := '.';
     end;
     write(fichier,nombre,' ')
end;

Procedure EcritGraphe;
var i,n : integer;
    v : indiceVoie;
begin with Graphe do begin
   writeln(fichier,symbReg,'0 GRAPHE VAR');
   n := 0;
   for v := voie0 to voieAnaMax do
       if voieOrphy[v].Yvisible then inc(n);
   writeln(fichier,symbReg2,n,' TRACE');
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
       if Yvisible then
          if traceLigne
             then if traceMotif
                  then writeln(fichier,'3')
                  else writeln(fichier,'2')
             else writeln(fichier,'1');
   writeln(fichier,symbReg2,n,' COULEUR');
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
       if Yvisible then writeln(fichier,couleur);
   writeln(fichier,symbReg2,n,' MOTIF');
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
       if Yvisible then writeln(fichier,ord(Motif));
   writeln(fichier,symbReg2,n,' X');
   for i := 1 to n do
       ecritChaineRW3(voieOrphy[voieAbscisse].nom);
   writeln(fichier,symbReg2,n,' Y');
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
       if Yvisible then ecritChaineRW3(nom);
end end;  // ecritGraphe

Procedure EcritBase;
var j,v : integer;
begin with graphe do begin
    writeln(fichier,symbReg,'1 PAGE COMMENT');
    ecritChaineRW3(ConstanteDlg.editComm.text);
    writeln(fichier,symbReg2,IntToStr(NbreAff)+' VALEUR VAR');
    for j := 0 to pred(NbreAff) do begin
       if avecNum then
          writeNombreWin(voieOrphy[v1].vecteurAff[j]);
       for v := voie0 to voieAnaMax do
           if voieOrphy[v].active and (v<>v1) then
              writeNombreWin(voieOrphy[v].vecteurAff[j]);
           writeln(fichier);
    end; // for j
end end;

Procedure EcritPage(page : integer);
var j,i,v : integer;
begin with graphe do begin
    writeln(fichier,symbReg,'1 PAGE COMMENT');
    ecritChaineRW3('');
    writeln(fichier,symbReg2,IntToStr(oldNbre[page])+' VALEUR VAR');
    for j := 0 to pred(oldNbre[page]) do begin
       if avecNum then
          writeNombreWin(voieOrphy[v1].oldVecteur[page,j]);
       for v := voie0 to voieAnaMax do
           if voieOrphy[v].active and (v<>v1) then
                writeNombreWin(voieOrphy[v].oldVecteur[page,j]);
           writeln(fichier);
       if ListeRepere.count>0 then begin
          ecritChaineRW3(symbReg2+IntToStr(ListeRepere.count)+' REPERE');
          for i := 0 to pred(ListeRepere.count) do begin
             repere := listeRepere[i];
             writeNombreWin(repere.valeur);
             ecritChaineRW3(crTab+repere.edit.text);
          end;
       end;
    end; // for j
end end; // ecritPage

Procedure ecritEnTete;
var i,v : integer;
    NbreVariab : integer;
begin // ecritEnTete
with graphe do begin
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   if avecNum
        then NbreVariab := 1
        else NbreVariab := 0;
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
        if active then inc(NbreVariab);
   writeln(fichier,symbReg,NbreVariab,' NOM VAR');
   if avecNum then if (modeAcq=AcqPoint)
        then ecritChaineRW3('num')
        else ecritChaineRW3(voieOrphy[v1].nom);
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
        if active and (v<>v1) then ecritChaineRW3(nom);
   writeln(fichier,symbReg,NbreVariab,' GENRE VAR');
   for i := 0 to pred(NbreVariab) do
       writeln(fichier,0);
   writeln(fichier,symbReg,NbreVariab,' UNITE VAR');
   if avecNum then if (modeAcq=AcqPoint)
        then ecritChaineRW3('')
        else ecritChaineRW3(voieOrphy[v1].nomUnite);
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
       if active and (v<>v1) then ecritChaineRW3(nomUnite);
   writeln(fichier,symbReg,NbreVariab,' PRECISION VAR');
   for i := 0 to pred(NbreVariab) do
       writeln(fichier,4);
   writeln(fichier,symbReg,NbreVariab,' SIGNIF VAR');
   if avecNum then if (modeAcq=AcqPoint)
      then ecritChaineRW3('index d''acquisition')
      else ecritChaineRW3(voieOrphy[v1].signif);
   for v := voie0 to voieAnaMax do with voieOrphy[v] do
       if active and (v<>v1) then ecritChaineRW3(signif);
   writeln(fichier,symbReg,'2 ACQUISITION');
   writeln(fichier,'Externe');
   writeln(fichier,application.exeName);
end end; // ecritEnTete

var v,vv : indiceVoie;
    i : integer;
begin with graphe do begin // EnvoieFichier
     Screen.Cursor := crHourGlass;
// vrification des noms et des doublons
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then begin
            if nom='' then if (capsule<>nil) and capsule.useEF0
               then nom := 'f'
               else nom := 'U';
            if not charInSet(nom[1],majuscule+minuscule) then
               if (capsule<>nil) and capsule.useEF0
                  then nom := 'f'+nom
                  else nom := 'U'+nom;
         end;
     for v := voie0 to voieAnaMax do
         if voieOrphy[v].active then
            for vv := succ(v) to voieAnaMax do
                if voieOrphy[vv].active and
                   (voieOrphy[vv].nom=voieOrphy[v].nom) then begin
                      voieOrphy[v].nom := voieOrphy[v].nom+intToStr(v);
                      voieOrphy[vv].nom := voieOrphy[vv].nom+intToStr(vv);
                end;
     NomFichier := AppDataDir+'orphylab.rw3';
     AssignFile(fichier,NomFichier);
     Rewrite(fichier);
     avecNum := (modeAcq<>AcqPoint) or OrphyLabMain.sauveNum;
     if avecNum then
     case modeAcq of
          AcqTemps : v1 := voieT;
          AcqPoint : for i := 0 to maxVecteur do
              voieOrphy[voieT].vecteurAff[i] := i;
          AcqClavier : v1 := voieClavier;
          else v1 := voieT;
     end
     else v1 := voieCalc;
     ecritEnTete;
     ecritGraphe;
     ecritBase;
     for i := 1 to NbrePages do ecritPage(i);
     CloseFile(fichier);
     Execute(eFileLoad,nomFichier);
     Screen.Cursor := crDefault;
end end; // EnvoieFichier

procedure TOrphyLabDDE.AjouteDonnees(debut,fin : integer);
var i : indiceVecteur;
    v : indiceVoie;
    ligne : string;
    ligneOK : boolean;
    donnees : TstringList;
begin with graphe do begin
     if debut=0 then begin
        envoieDonnees(true,'');
        exit;
     end;
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     ligne := voieOrphy[voieT].nom+crTab;
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then
            ligne := ligne + nom + crTab;
     with voieCalculee do
         if active then ligne := ligne + nom;
     donnees.Add(ligne);
     ligne := voieOrphy[voieT].nomUnite+crTab;
     for v := voie0 to voieAnaMax do with voieOrphy[v] do
         if active then
            ligne := ligne + nomUnite + crTab;
     with voieCalculee do
         if active then ligne := ligne + nomUnite;
     donnees.Add(ligne);
     ligne := voieOrphy[voieT].signif+crTab;
     for v := voie0 to voieAnaMax do
         if voieOrphy[v].active then
            ligne := ligne + voieOrphy[v].signif + crTab;
     with voieCalculee do
         if active then ligne := ligne + signif;
     donnees.Add(ligne);
     for i := debut to fin do begin
         ligneOK := true;
         ligne := FloatToStrPoint(voieOrphy[voieT].vecteurAff[i]) + crTab;
         for v := voie0 to voieAnaMax do with voieOrphy[v] do
             if active then if isNan(vecteurAff[i])
                then ligneOK := false
                else ligne := ligne+FloatToStrPoint(vecteurAff[i]) + crTab;
         with voieCalculee do
            if active then ligne := ligne + FloatToStrPoint(vecteurAff[i]);
         if ligneOK then donnees.Add(ligne);
     end; { for i }
     ClipBoard.astext := Donnees.text;
     Execute(ePLUS,'');
     donnees.free;
     Screen.Cursor := crDefault;
end end; // AjouteDonnees

procedure TOrphyLabDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : string;
    ArgStart,ArgEnd : integer;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then nomFichier := ''
          else nomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
       ArgStart := Pos('(',Msg[0]);
       if ArgStart>0
          then Fonction := Copy(Msg[0], 1, Pred(ArgStart))
          else Fonction := Msg[0];
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) then begin
          nomFichier := changeFileExt(nomFichier,extConfigPortable);
          if FileExists(nomFichier) and (nomFichier<>nomFichierConfig) then
             OrphyLabMain.litConfig(nomFichier);
          exit;
       end;
       if (CompareText('CONFIG|SAVE',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) then begin
          OrphyLabMain.ecritConfig(nomFichier);
          exit;
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           OrphyLabMain.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           OrphyLabMain.setFocus;
           exit;
       end;
    //   MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
           // MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
    // else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;

end.
