unit OrphyLabDef;

interface

uses classes, types, sysutils, inifiles, graphics, forms,
     uniteker, maths, math,
     orphyLabUtil, orphyLabConst,
     oomisc, adport;

Const
    NbreInterMin = 10;
    NbreFiltre50Hz = 20; // 20 points sur 20 ms 
    deltatZper = 100; // s
    timerIntTemps = 165;
    timerIntMagnum = 250;
    timerIntRadar = 330;
    timerIntCardiaque = 500;
    timerIntPoint = 300;    
    MinRadar = 32; // 20 cm
    MaxRadar = 700; // 3 mtres
    DureeMaxCardiaque = 300; // 300 s ; 5 minutes
    MaxMoyCardiaque = 200; // coups soit environ 3 minutes
    timerIntReco = 700;
    DureeIncrementiel = 10*60; // dure minimale de sauvegarde en cours de route
    periodeMagnum = 0.0018;   // demi pas
    deltatRadarAuto = 0.03277;
    deltatMinRadar = 10*deltatRadarAuto;
    CoeffRadarTemps = 25e-6/2; // 25 s priode d'chantillonage ; /2 aller retour
    MaxRadarTemps = MaxRadar*CoeffRadarTemps;
    VitesseSon = 344; // 344 m/s vitesse du son  20 C
// soit 4,3 mm et donc mini  108 mm (0+25) Maxi 3 m (675+25)
    periodeMagnumE : double = PeriodeMagnum;
    zeroMagnum = 30000;
    deltatMagnum = 125e-9;
// unit de temps de codage des fronts
// OrphyLAB 36 MHz et mOrphy2 30MHz
    deltatEF = 65536*125e-9; // unit de temps de codage des fronts
    crLF = #10;
    crCR = #13;
    premiereFois : boolean = true;
// codage par numro
    indexRadar = 85; geneRadar = 0;
    indexSynchro = 30; geneSynchro = 0;
    indexStimul = 80; geneStimul = 1;
    indexCardiaque = 127; geneCardiaque = 0;
    indexMagnum = 220; geneMagnum = 0;
    indexECG = 102; geneECG = 0;
    indexCardiaqueBis = 229; geneCardiaqueBis = 0;
    indexOxymetre = 96; geneOxymetre = 1;

    voieT = 13;
    voieClavier = 11;
    voieCalc = 12;
    voieCapteur = 10; // sur U3
    voieMax = voieT;
    voie0 = 0;
    voie1 = 1;
    voie2 = 2;
    voie3 = 3;
    voieMicroMax = voie3;
    voieI1 = 4;
    voieI2 = 5;
    voieI3 = 6;
    voieU1 = 7;
    voieU2 = 8;
    voieU3 = 9;
    voieLabMax = 9;
    voieLabMin = 4;
    voieMin = 0;
    MaxiHard = 4096; // 12 bits
    MinPoints = 4;
    MaxPages = 15;
    pasPage = 4; // 4*64 = 256
    ZeroCapsulePermis : boolean = false;
    NbreTestMax = 10;
    OrdreSynchroTest = ansichar(108)+ansichar(0)+ansichar(0)+ansichar(0)+
                       ansichar(0)+ansichar(0)+ansichar(8);
    OrdreTestU = ansichar(105)+ansichar(4)+ansichar(NbreTestMax)+ansichar(0)+
                 ansichar(100)+ansichar(0)+
                 ansichar(10)+ansichar(0)+ansichar(0)+
                 ansichar(1)+ansichar(8)+ansichar(9)+ansichar(10)+ansichar(11);
    OrdreTestI = ansichar(105)+ansichar(4)+ansichar(NbreTestMax)+ansichar(0)+
                 ansichar(100)+ansichar(0)+
                 ansichar(10)+ansichar(0)+ansichar(0)+
                 ansichar(1)+ansichar(12)+ansichar(13)+ansichar(14)+ansichar(15);

type
    TcasParticulier = (cNone,cRadar,cSynchro,cStimul,cCardiaque,cMagnum,cECG,cOxymetre);
    Tsignal = (sCarre,sTriangle,sSinus,sContinu,sArbitraire);
    indicePage = 0..maxPages;
    TmodeFrequence = (mCompte200ms, mCompte1s, mPeriode);
    TdataMagnum = record case boolean of
         false : (octets : array[0..5] of byte);
         true : (date : longWord;position : word);
    end;
    Tmotif = (mCroix,mCroixDiag,mCercle,mCarre,mLosange);
    TModeAcq = (AcqClavier,AcqTemps,AcqPoint,AcqMagnum,
                AcqRadar,AcqTestU,AcqTestI,AcqCardiaque);
    TetatAcq = (eaAttenteSynchro,eaAttenteResul,eaMajResul,
                eaTerminee,eaStop);
    TetatAvail = (eaMemo,eaResul,eaLitMagnum,eaResul50Hz,
                  eaRadarAuto,eaNone,eaTestU,eaTestI,eaCardiaque,eaReco);
    indiceVoie = voieMin..VoieMax;
    indiceVoieAna = voie0..Voie3;
    TModeSynchro = (S_relaxe,S_seuil,S_clavier,S_front);
    EserieError = class(Exception);
    EgtiError = class(Exception);
    indice50Hz = 0..NbreFiltre50Hz;
    Tvecteur50Hz = array[indice50Hz] of word;
    TlongWordCarac = record
    case byte of
         0: (caracs: array[0..3] of AnsiChar);
         1: (valeurLW: longword);
         2: (valeurW: array[0..1] of word);
         3: (valeurB: array[0..3] of byte);
    end;
    TWordCarac = record
    case byte of
         0: (caracs: array[0..1] of AnsiChar);
         1: (valeurW: word);
         2: (valeurB: array[0..1] of byte);
    end;

Const
    recoMagnum = 220;
    codeBool : array[boolean] of ansiChar = (#0,#1); // false 0 true 1
    DeltatMax = 300.0; // 300 s = 5 min
    DureeMax = deltatMax*MaxVecteur; // 8192*5 min = 1 mois
    DureeMin = 1e-4; // 100 s = 50 points * 2 s
    DeltatOrphy36MHz = 5e-6;
    DeltatOrphy120MHz = 2e-6;
    NbreCapsulesMaxi = 255;
    nomFB : array[4..10] of string = ('I1','I2','I3','U1','U2','U3','U3');

type
   indiceCardiaque = 0..MaxMoyCardiaque;
   indiceCapsule = 0..NbreCapsulesMaxi;
   TutilisationEF = (fSynchro,fFrequence);
   Tcapsule = class(Tobject)
      DoubleCalibre : boolean;
      UseEF0 : boolean;
      nomUniteC,nomUniteAutre : string;
      nomC,nomAutre : string;
      Etalonnage : boolean;
      SignifC,SignifCBis : string;
      capteurC,capteurCBis : string;
      titreC,titreCBis : string;
      Valeur0,valeur1024,valeur0Bis,valeur1024Bis : extended;
      NumeroMicrelec : string;
      ValeurRecon : integer;
      Gamme : integer;
      doubleCalibreCapteur : boolean;
      casParticulier : TcasParticulier;
      capteurPosNeg : boolean;
      nbreDecimaleC : integer;
      Constructor Create;
      Procedure Load(fichier : TMemInifile;index : integer);
   end;

   Tvoie = class(Tunite)
          Capsule : Tcapsule;
          useEF0 : boolean;
          NumeroOrphy : integer;
          ValeurCourante,valeurAff : double;
          ValeurHard : integer;
          UseBis,calibreBis : boolean;
          signif,titre,capteur : string;
          Mini,Maxi : double;
          MaxiCapteur,MiniCapteur : double;
          vecteurCourant,vecteurAff : vecteur;
          oldVecteur : array[indicePage] of vecteur;
          vecteur50Hz : Tvecteur50Hz;
          active : boolean;
          couleur : Tcolor;
          Motif : Tmotif;
          exposantAff : double;
          nbreAvantVirgule : integer;
          withVirgule : boolean;
          configCharge : boolean;
          EtalonnageFait : boolean;
          offset : integer; // dcalage du zro
          utilisationEF : TutilisationEF;
          filtrage50Hz : boolean;
          nomUniteAff : string;
          constructor create(num : integer);
          Function CodeVoie : ansiChar;
          Function CodeFront : ansiChar;
          Function GBcaption : string;
          procedure CalculMinMax;
          procedure setMinMax(valeur1,valeur2 : double);
          Function ValeurInt(V : double) : word;
          Function ValeurReal(V : word) : double; virtual;
          Function ValeurFiltre : double;
          procedure RazVecteur;
          Function AffVoltmetre : string;
          Function AffValeur(value : double) : string;
          Function isSynchro : boolean;
          Function isFrequence : boolean;
          function ZEA : ansichar;
          function ZRBIT : ansichar;
          function ZEBIT : ansichar;
          function ZSBIT : ansichar;
    end;

   TCapteur = class(Tobject)
        ZeroVoltC : double;
        UnVoltC : double;
        nomC : string;
        nomUniteC : string;
        signifC,aideC,titreC : string;
        MiniC,MaxiC : double;
        isLumicolorC,isPhotocolorC : boolean;
        nbreDecimaleC : integer;
        constructor create;
        Procedure Load(fichier : TMemInifile;index : integer);
        Procedure Save(fichier : TMemInifile;index : integer);
   end;

  TlisteCapteur = class(TList)
  protected
    function Get(Index : Integer) : Tcapteur;
    procedure Put(Index : Integer;Item : Tcapteur);
  public
    function Add(Item : Tcapteur) : Integer;
    function IndexOf(Item : Tcapteur) : Integer;
    function Remove(Item : Tcapteur) : Integer;
    property Items[Index : Integer] : Tcapteur read Get write Put;
    Procedure Clear;override;
  end;

var
    Capsules : array[0..1,indiceCapsule] of TCapsule;
    ListeCapteur : TlisteCapteur;
    AvecExposant : boolean;
    maxiOxymetrePc : double = 42; // PC pour cent %
    magnumChuteNegatif : boolean;
    radar_position : boolean = true;
    tensionRefLumicolor : double = 4.3;
    tensionRefPhotocolor : double = 0.1;
    isOrphyLab : boolean;
    ModeFrequence:  TmodeFrequence;
    NbreMoyCardiaque : indiceCardiaque = 20; // coups soit environ 20 secondes
    UniteVolt : Tunite;
    DureeMaxMagnum : integer = 0;
    remanence : boolean = true;
    boutonObligatoire : boolean = false;

Function positionRadar(valeurRadar : word) : double;
Function ValeurPortable(carac1,carac2 : AnsiChar) : word;
Function CodeValeur2(valeur : longWord) : ansiString;
Function CodeValeur3(valeur : longWord) : ansiString;
Function AffFrequence(value : double) : string;
Procedure SauveListeCapteurs;

function nomEtat(etat : TetatAcq) : string;
function nomModeAcq(mode : TModeAcq) : string;
function nomSynchro(mode : TModeSynchro) : string;
function caracNom(key : char) : boolean;

implementation

var
    oldPositionRadar : double;
    compteurRadar : integer;
    CouleurDefaut : array[indiceVoie] of Tcolor =
       (clBlue,clRed,clGreen,clBlack,
        clBlue,clRed,clGreen,
        clBlue,clRed,clGreen,
        clBlack,clBlack,clBlack,clBlack);

Procedure ChargeListeCapsules;
var fichier : TMemIniFile;

Procedure ChargeCapteurs;
var i : integer;
    NbreCapteurs : integer;
    CapteurCourant : Tcapteur;
begin
    listeCapteur := TlisteCapteur.create;
    NbreCapteurs := fichier.readInteger('Capteurs','Nombre',0);
    for i := 1 to NbreCapteurs do begin
      CapteurCourant := Tcapteur.create;
      CapteurCourant.Load(fichier,i);
      ListeCapteur.add(CapteurCourant);
    end;
    if NbreCapteurs=0 then begin
       CapteurCourant := TCapteur.create;
       ListeCapteur.add(CapteurCourant);
    end;
end; // ChargeCapteurs

const NbreCapsulesFichier = 62;
var i : integer;
    aCapsule : Tcapsule;
    RS: TResourceStream;
    SauvegardeFichier : TstringList;
begin
    fichier := TMemIniFile.create(nomFichierCapteur);
    if not FileExists(NomFichierCapteur) then begin
       RS := TResourceStream.Create(HINSTANCE, 'FichierCapteurId', RT_RCDATA);
       SauvegardeFichier := TstringList.create;
       SauvegardeFichier.LoadFromStream(rs);
       fichier := TMemIniFile.create(nomFichierCapteur);
       fichier.SetStrings(SauvegardeFichier);
       SauvegardeFichier.Free;
    end;
    for i := 1 to NbreCapsulesFichier do begin
        aCapsule := Tcapsule.create;
        aCapsule.load(fichier,i);
        case aCapsule.valeurRecon of
             indexRadar : if aCapsule.gamme=geneRadar then aCapsule.casParticulier := cRadar;
             indexSynchro : if aCapsule.gamme=geneSynchro then aCapsule.casParticulier := cSynchro;
             indexStimul : if aCapsule.gamme=geneStimul then aCapsule.casParticulier := cStimul;
             indexCardiaque : if aCapsule.gamme=geneCardiaque then aCapsule.casParticulier := cCardiaque;
             indexCardiaqueBis : if aCapsule.gamme=geneCardiaqueBis then aCapsule.casParticulier := cCardiaque;
             indexMagnum : if aCapsule.gamme=geneMagnum then aCapsule.casParticulier := cMagnum;
             indexECG : if aCapsule.gamme=geneECG then aCapsule.casParticulier := cECG;
             indexOxymetre : if aCapsule.gamme=geneOxymetre then aCapsule.casParticulier := cOxymetre;
             else aCapsule.casParticulier := cNone;
        end;
        if aCapsule.valeurRecon>0
           then capsules[aCapsule.gamme,aCapsule.valeurRecon] := aCapsule
           else aCapsule.Free;
    end;
    ChargeCapteurs;
    fichier.free;
end; // ChargeListeCapsules

Constructor Tvoie.create(num : integer);
begin
     inherited create;
     signif := '';
     Mini := -5;
     Maxi := 5;
     useEF0 := false;
     MiniCapteur := -5;
     MaxiCapteur := 5;
     ValeurCourante := 0;
     ValeurAff := 0;
     numeroOrphy := num;
     useBis := false;
     Motif := mCroix;
     couleur := CouleurDefaut[num];
     exposantAff := 1;
     nbreAvantVirgule := 2;
     withVirgule := true;
     configCharge := false;
     Offset := 0;
end;

Procedure Tvoie.CalculMinMax;
var MaxMax : double;                     
    exponent : integer;
    unite:  coefUnite;
begin                                      
   ValeurAff := valeurCourante;
   MaxMax := abs(maxiCapteur);
   if MaxMax<abs(miniCapteur) then MaxMax := abs(miniCapteur);
   if avecExposant and
      (nomUnite<>'tr/min') and
      (nomUnite<>'mS/cm')
      then begin
        Exponent := Plancher(Log(MaxMax));
        if (Exponent mod 3) < 0
           then Exponent := (Exponent div 3)-1
           else Exponent := Exponent div 3;
// la division euclidienne des informaticiens <> div des maths !
        ExposantAff := Dix(3*Exponent);
        unite := coefUnite(exponent + Ord(nulle));
        nomUniteAff := nomAff(puissanceUnite[unite]);
      end
      else begin
         ExposantAff := 1;
         nomUniteAff := nomUnite;
      end;
   NbreAvantVirgule := Plancher(Log(MaxMax/ExposantAff))+1;
   WithVirgule := NbreAvantVirgule<4;
end; // calculMinMax

function Tvoie.GBcaption : string;
begin
   if pos('/', NomUniteAff) > 0 then
         Result := nom + '(' + nomUniteAff + ')'
      else if NomUniteAff=''
         then Result := nom
         else Result := nom + ' / ' + nomUniteAff
end;

Procedure Tvoie.setMinMax(valeur1,valeur2 : double);
var
    maxmax: double;
    exponent: integer;
    unite: coefUnite;
begin
   if valeur1>valeur2
      then begin
           maxiCapteur := valeur1;
           miniCapteur := valeur2;
      end
      else begin
           maxiCapteur := valeur2;
           miniCapteur := valeur1;
      end;
   MaxMax := abs(maxiCapteur);
   if MaxMax < abs(miniCapteur) then
      MaxMax := abs(miniCapteur);
   Exponent := floor(Log10(MaxMax));
   if (Exponent mod 3) < 0
      then Exponent := (Exponent div 3) - 1
      else Exponent := Exponent div 3;
   // la division euclidienne des informaticiens <> div des maths !
   if nomUnite='tr/min' then exponent := 0;
   ExposantAff := Dix(3*Exponent);
   unite := coefUnite(exponent + Ord(nulle));
   nomUniteAff := nomAff(puissanceUnite[unite]);
   NbreAvantVirgule := Plancher(Log(MaxMax/ExposantAff))+2;
   WithVirgule := NbreAvantVirgule<4;
   Maxi := MaxiCapteur;
   Mini := MiniCapteur;
end; // setMinMax

function Tvoie.CodeVoie : ansichar;
begin
     if UseBis
        then result := ansichar(4+numeroOrphy)
        else result := ansichar(numeroOrphy)
end;

function Tvoie.ZEA : ansichar;
begin
     if UseBis
        then result := ansichar(68+numeroOrphy)
        else result := ansichar(64+numeroOrphy)
end;

function Tvoie.ZRBIT : ansichar;
begin
     if UseBis
        then result := ansichar(4+numeroOrphy)
        else result := ansichar(numeroOrphy)
end;

function Tvoie.ZSBIT : ansichar;
begin
     if UseBis
        then result := ansichar(32+4+numeroOrphy)
        else result := ansichar(32+numeroOrphy)
end;

function Tvoie.ZEBIT : ansichar;
begin
     if UseBis
        then result := ansichar(96+4+numeroOrphy)
        else result := ansichar(96+numeroOrphy)
end;

function Tvoie.CodeFront : ansichar;
begin
    codeFront := ansichar(numeroOrphy)
end;

Function Tvoie.ValeurReal(V : word) : double;
begin
     result := MiniCapteur+(MaxiCapteur-MiniCapteur)*(V+offset)/MaxiHard
end;

Function Tvoie.ValeurFiltre : double;
var total : longWord;
    i : integer;
begin
    total := 0;
    for I := 0 to pred(NbreFiltre50Hz) do
        total := total + vecteur50Hz[i];
    result := valeurReal(round(total/NbreFiltre50Hz))
end;

Function Tvoie.ValeurInt(V : double) : word;
begin
      result := offset+round(maxiHard*(V-miniCapteur)/(maxiCapteur-miniCapteur))
end;

procedure Tvoie.RazVecteur;
var i : integer;
begin
    for i := 0 to MaxVecteur do begin
       vecteurAff[i] := 0;
       vecteurCourant[i] := 0;
    end;
end;

Function Tvoie.isSynchro : boolean;
begin
   result := (capsule<>nil) and
             active and
             (capsule.casParticulier=cSynchro) and
             (utilisationEF=fSynchro)
end;

Function Tvoie.isFrequence : boolean;
begin
   result := (capsule<>nil) and
             active and
             (capsule.casParticulier=cSynchro) and
             (utilisationEF=fFrequence)
end;

procedure Tcapsule.load(fichier : TMemInifile;index : integer);
var section : string;
begin
        Section := 'Capsule'+IntToStr(index);
        try
        valeurRecon := Fichier.readInteger(Section,'Reco',0);
        gamme := Fichier.readInteger(Section,'Gene',0);
        if gamme>1 then gamme := 1;
        if gamme<0 then gamme := 0;
        signifC := Fichier.readString(section,'Signif','');
        signifCBis := Fichier.readString(section,'SignifBis','');
        capteurC := Fichier.readString(section,'Capteur','');
        capteurCBis := Fichier.readString(section,'CapteurBis','');
        titreC := Fichier.readString(section,'Titre','');
        titreCBis := Fichier.readString(section,'TitreBis','');
        nomAutre := fichier.readString(section,'SymbAutre','');
        nomUniteAutre := fichier.readString(section,'UniteAutre','');
        NbreDecimaleC := fichier.readInteger(section,'NbreDecimale',-1);
        nomUniteC := Fichier.readString(Section,'Unite','');
        nomC := Fichier.readString(Section,'Symb','');
        if nomc='sigma' then nomc := sigma;
        if nomc='theta' then nomc := theta;
        if nomc='Sigma' then nomc := sigmaMaj;
        if nomc='Theta' then nomc := thetaMaj;
        if nomc='alpha' then nomc := alpha;
        if nomc=thetaR then nomc := theta;
        useEF0 := Fichier.readBool(Section,'UseEF0',false);
        doubleCalibre := Fichier.readBool(Section,'UseEA4',false);
        doubleCalibreCapteur := Fichier.readBool(Section,'DeuxCalibres',false);
        Etalonnage := Fichier.readBool(Section,'Etalonnage',false);
        valeur0 := Fichier.readFloat(Section,'Min0',0);
        valeur1024 := Fichier.readFloat(Section,'Max0',1);
        valeur0Bis := Fichier.readFloat(Section,'Min4',0);
        valeur1024Bis := Fichier.readFloat(Section,'Max4',1);
        numeroMicrelec := Fichier.readString(Section,'Micrelec','0');
        capteurPosNeg := pos('',titreC)>0;
        except
        end;
end;

procedure Tcapteur.load(fichier : TMemInifile;index : integer);
var section : string;
begin
        Section := 'Capteur'+IntToStr(index);
        try
        ZeroVoltC := Fichier.readFloat(section,'0V',0);
        UnVoltC := Fichier.readFloat(section,'1V',1);
        nomC := Fichier.readString(section,'Nom','X');
        if nomc='sigma' then nomc := sigma;
        if nomc='theta' then nomc := theta;
        nomUniteC := Fichier.readString(section,'Unite','');
        NbreDecimaleC := Fichier.readInteger(section,'NbreDecimale',-1);
        signifC := Fichier.readString(section,'Signif','');
        aideC := Fichier.readString(section,'Aide','');
        titreC := Fichier.readString(section,'Titre','');
        MiniC := Fichier.readFloat(Section,'Mini',0);
        MaxiC := Fichier.readFloat(Section,'Maxi',1);
        isLumicolorC := Fichier.readBool(section,'Lumicolor',false);
        isPhotocolorC := Fichier.readBool(section,'Photocolor',false);
        except
        end;
end;

procedure Tcapteur.save(fichier : TMemInifile;index : integer);
var section : string;
begin
        Section := 'Capteur'+IntToStr(index);
        try
        Fichier.writeFloat(Section,'0V',ZeroVoltC);
        Fichier.writeFloat(Section,'1V',Unvoltc);
        Fichier.writeString(section,'Nom',nomc);
        Fichier.writeString(section,'Unite',nomUnitec);
        Fichier.writeString(section,'Signif',signifc);
        Fichier.writeString(section,'Aide',aidec);
        Fichier.writeString(section,'Titre',titrec);
        Fichier.writeFloat(Section,'Mini',minic);
        Fichier.writeFloat(Section,'Maxi',maxic);
        Fichier.writeBool(section,'Lumicolor',isLumicolorC);
        Fichier.writeBool(section,'Photocolor',isPhotocolorC);
        except
        end;
end;

Constructor Tcapsule.Create;
begin
    DoubleCalibre := false;
    UseEF0 := false;
    SignifC := '';
    SignifCBis := '';
    CapteurC := '';
    CapteurCBis := '';
    TitreC := '';
    TitreCBis := '';

    Valeur0 := 0;
    valeur0Bis := 0;
    valeur1024 := 1;
    valeur1024Bis := 1;
    NumeroMicrelec := '';
    ValeurRecon := 0;
    Gamme := 0;
    nomC := '';
    nomUniteC := '';
end;

Function ValeurPortable(carac1,carac2 : AnsiChar) : word;
begin
      result := ord(carac1) + ord(carac2) shl 8
end;

Function Tvoie.AffVoltmetre : string;
var posVirgule,i : integer;
    negatif : boolean;
    valeur : double;
begin
 if isNan(valeurAff)
    then result := ''
    else if utilisationEF=fFrequence
         then begin
           if nomUnite='Hz' then
           case modeFrequence of
               mCompte200ms: if exposantAff=1
                    then result := intToStr(round(valeurAff))
                    else result := FloatToStrF(valeurAff/ExposantAff,ffFixed,5,2);
                    // 10 Hz prs
               mCompte1s: if exposantAff=1
                    then result := intToStr(round(valeurAff))
                    else result := FloatToStrF(valeurAff/ExposantAff,ffFixed,5,3);
                    // 1 Hz prs
               mPeriode: if exposantAff=1
                    then if valeurAff<1
                       then result := FloatToStrF(valeurAff,ffFixed,5,3)
                       else if valeurAff<10
                            then result := FloatToStrF(valeurAff,ffFixed,5,2)
                            else result := FloatToStrF(valeurAff,ffFixed,5,1)
                    else result := FloatToStrF(valeurAff/ExposantAff,ffFixed,5,4);
         end;// case
         if nomUnite='tr/min' then result := intToStr(round(valeurAff)); // 600 tr/min prs
       end
       else if withVirgule
       then begin
           negatif := valeurAff<0;
           valeur := abs(valeurAff)/ExposantAff;
           if NbreDecimaleFixe=0
              then Result := IntToStr(round(valeur))
              else if NbreDecimaleFixe>0
                then result := FloatToStrF(valeur,ffFixed,precisionPortable,nbreDecimaleFixe)
                else result := FloatToStrF(valeur,ffFixed,precisionPortable,precisionPortable-NbreAvantVirgule);
           posVirgule := pos('.',result);
           if negatif
              then result := '-'+result
              else result := '+'+result;
           for i := 1 to (NbreAvantVirgule-posVirgule) do
               result := ' '+result;
       end
       else begin
           result := IntToStr(round(valeurAff/ExposantAff));
           if valeurAff>0 then result := '+'+result;
           posVirgule := length(result);
           for i := 1 to (precisionPortable-posVirgule) do
                result := ' '+result;
       end;
end;

Function Tvoie.AffValeur(value : double) : string;
var posVirgule,i : integer;
    negatif : boolean;
    valeur : double;
begin
    if withVirgule
       then begin
           negatif := value<0;
           valeur := abs(value)/ExposantAff;
           result := FloatToStrF(valeur,ffFixed,precisionPortable,precisionPortable-NbreAvantVirgule);
           posVirgule := pos('.',result);
           for i := 1 to (NbreAvantVirgule-posVirgule) do
               result := ' '+result;
           if negatif
              then result := '-'+result
              else result := '+'+result
       end
       else begin
           result := IntToStr(round(value/ExposantAff));
           if value>0 then result := '+'+result;
           posVirgule := length(result);
           for i := 1 to (precisionPortable-posVirgule) do
                result := ' '+result;
       end;
end;

function nomEtat(etat : TetatAcq) : string;
begin
     case etat of
          eaAttenteSynchro : result := trWaitSynchro;
          eaAttenteResul : result := trAcqEnCours;
          eaMajResul : result := trMajResul;
          eaTerminee : result := trAcqFinie;
          eaStop : result := '';
     end;
end;

function nomModeAcq(mode : TModeAcq) : string;
begin
     case mode of
          AcqClavier : result := trClavier;
          AcqTemps : result := trTemporel;
          AcqPoint : result := trPointParPoint;
          AcqMagnum : result := trMagnum;
          AcqRadar : result := trRadar;
     end;
end;

Function CodeValeur2(valeur : longWord) : ansiString;
begin
     result := ansiChar(valeur mod 256) + ansiChar(valeur div 256)
// basse puis haute
end;

Function CodeValeur3(valeur : longWord) : ansiString;
var lw : TlongWordCarac;
begin
     lw.valeurLW := valeur;
     result := ansichar(lw.caracs[0]) + ansiChar(lw.caracs[1]) + ansiChar(lw.caracs[2]);
end;

function nomSynchro(mode : TModeSynchro) : string;
begin
     case mode of
         S_front : result := trFront;
         S_seuil : result := trSeuil;
         S_relaxe : result := trRelaxe;
         S_clavier : if boutonObligatoire
           then result := trBouton
           else result := trBarre;
    end;
end;

function positionRadar(valeurRadar : word) : double;
begin
      if (valeurRadar < MinRadar) or
         (valeurRadar > MaxRadar)
             then if compteurRadar>4
                   then result := Nan
                   else begin
                        inc(CompteurRadar);
                        result := oldPositionRadar;
                   end
             else begin
                 result := (valeurRadar + 13) * coeffRadarTemps;
                 if radar_position then result := result*VitesseSon;
                 compteurRadar := 0;
                 oldPositionRadar := result;
             end;
end;

Function AffFrequence(value : double) : string;
var exposant : integer;
begin
    exposant := trunc(log(value));
    if exposant<3
       then result := 'f='+intToStr(round(value))+' Hz'
       else result := 'f='+intToStr(round(value/1000))+' kHz'
end;

constructor Tcapteur.create;
begin
        ZeroVoltc := 0;
        unVoltc := 10;
        nomC := 'T';
        NomUniteC := 'C';
        signifC := 'Temprature';
        aideC := '';
        MiniC := 0;
        MaxiC := 50;
end;

function TlisteCapteur.Add(Item : Tcapteur) : Integer;
begin
     result := inherited Add(Item)
end;

function TlisteCapteur.Get(Index : Integer) : Tcapteur;
begin
  Result := Tcapteur(inherited Get(Index))
end;

function TlisteCapteur.IndexOf(Item : Tcapteur) : Integer;
begin
  Result := inherited IndexOf(Item)
end;

procedure TlisteCapteur.Put(Index : Integer;Item : Tcapteur);
begin
  inherited Put(Index,Item)
end;

function TlisteCapteur.Remove(Item : Tcapteur) : Integer;
begin
  Result := inherited Remove(Item);
  Item.free;
end;

Procedure TListeCapteur.clear;
var i : Integer;
begin
  for i := 0 to pred(Count) do Items[i].Free;
  inherited Clear;
end;

Procedure SauveListeCapteurs; // sauvegarde de la liste
Var i : integer;
    fichier : tMemIniFile;
begin
    fichier := TMemIniFile.create(nomFichierCapteur);
    fichier.writeInteger('Capteurs','Nombre',ListeCapteur.count);
    for i := 0 to pred(ListeCapteur.count) do
        ListeCapteur.items[i].Save(fichier,i+1);
    fichier.updateFile;
    fichier.free;
end;

procedure libereCapsules;
var i : indiceCapsule;
    j : integer;
begin
    for j := 0 to 1 do
        for i := 0 to NbreCapsulesMaxi do
            capsules[j,i].free
end;

function caracNom(key : char) : boolean;
begin
    result := (pos(key,grecque)>0) or
            charInSet(key,majuscule+minuscule+toucheEdition+chiffre)
end;

initialization
    AvecExposant := false;
    magnumChuteNegatif := true;
    isOrphyLab := false;
    oldPositionRadar := Nan;
    compteurRadar := 0;
    ChargeListeCapsules

finalization
    libereCapsules;

end.
