unit OrphyLabDlgU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils,Gauges, Grids, ImgList, ComCtrls,
  orphyLabUtil, orphyLabDef, orphyLabGraphe, orphyLabMainU, maths,
  etalon, aidekey, orphyLabConst;

type
  TOrphyLabDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    CancelBtn: TBitBtn;
    EtalonneBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    EditUnite: TEdit;
    CalibreRG: TRadioGroup;
    ZeroBtn: TBitBtn;
    Label3: TLabel;
    EditComment: TEdit;
    Timer: TTimer;
    Gauge: TProgressBar;
    EditValeur: TEdit;
    filtreCB: TCheckBox;
    AffichageGB: TGroupBox;
    NbreDecimaleLabel: TLabel;
    FormatFixeCB: TCheckBox;
    NbreDecimaleSE: TSpinEdit;
    CouleurCombo: TColorBox;
    PointCombo: TComboBoxEx;
    CapsuleBtn: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure EtalonneBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure CalibreRGClick(Sender: TObject);
    procedure ZeroBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormHide(Sender: TObject);
    procedure FormatFixeCBClick(Sender: TObject);
    procedure NbreDecimaleSEChange(Sender: TObject);
    procedure CapsuleBtnClick(Sender: TObject);
  private
    procedure CalibreCO2Click(Sender: TObject);
    procedure CalibreO2Click(Sender: TObject);
    procedure SetEtalonnage;
  public
    voieCourante : IndiceVoie;
    modif : boolean;
  end;

var
  OrphyLabDlg: TOrphyLabDlg;

implementation

uses zeroU, listeCapVolt, capsuleCfgU;

{$R *.DFM}

procedure TOrphyLabDlg.FormActivate(Sender: TObject);
begin
    modif := false;
    ZeroBtn.visible := ZeroCapsulePermis;
    with graphe.voieOrphy[voieCourante] do begin
          NbreDecimaleSE.value := NbreDecimaleFixe;
          formatFixeCB.Checked := NbreDecimaleFixe>=0;
          NbreDecimaleSE.Visible := FormatFixeCB.checked;
          NbreDecimaleLabel.visible := FormatFixeCB.checked;
          EtalonneBtn.visible :=
              ((capsule.nomUniteC='V') and (voieCourante in [voie0..voie3])) or
               capsule.etalonnage;
  // (voltmetre et capteur autonome) or phmetre/conductimetre
          CapsuleBtn.visible := (voieCourante in [voie0..voie3]);
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditComment.text := Signif;
          CalibreRG.visible :=
             capsule.doubleCalibre or
             capsule.doubleCalibreCapteur or
             (Capsule.casParticulier=cOxymetre);
          if capsule.doubleCalibreCapteur
             then CalibreRG.OnClick := CalibreCO2Click
             else CalibreRG.OnClick := CalibreRGClick;
          if UseBis or calibreBis
             then CalibreRG.ItemIndex := 1
             else CalibreRG.ItemIndex := 0;
          if Capsule.casParticulier=cOxymetre then begin
             CalibreRG.OnClick := CalibreO2Click;
             if nomUnite='%'
                 then CalibreRG.ItemIndex := 0
                 else CalibreRG.ItemIndex := 1;
             CalibreRG.Items[0] := 'Concentration en %';
             CalibreRG.Items[1] := 'Concentration en mg/L';
          end
          else begin
          if capsule.doubleCalibre
             then OrphyLabMain.ecritOrphy(ZRBIT+codeFront);
          CalibreRG.Items[0] := capsule.capteurC;
          CalibreRG.Items[1] := capsule.capteurCBis;
          end;
          SetEtalonnage;
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          filtreCB.checked := filtrage50Hz;
    end;
    Timer.enabled := orphyLabMain.orphyPresent;
end;

procedure TOrphyLabDlg.FormatFixeCBClick(Sender: TObject);
begin
  NbreDecimaleSE.Visible := FormatFixeCB.checked;
  NbreDecimaleLabel.visible := FormatFixeCB.checked;
end;

procedure TOrphyLabDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     timer.enabled := false
end;

procedure TOrphyLabDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TOrphyLabDlg.FormHide(Sender: TObject);
begin
   timer.enabled := false;
end;

procedure TOrphyLabDlg.SetEtalonnage;
begin
      if graphe.voieOrphy[voieCourante].capsule.nomUniteC='V'
      then EtalonneBtn.caption := trChoixCapteur
      else if graphe.voieOrphy[voieCourante].EtalonnageFait
         then EtalonneBtn.caption := trMesured
         else EtalonneBtn.caption := trEtaloni
end;

procedure TOrphyLabDlg.TimerTimer(Sender: TObject);
var valeur : word;
begin with graphe.voieOrphy[voieCourante] do begin
     try
     valeur := OrphyLabMain.getWord(ZEA);
     Gauge.position := valeur;
     valeurAff := valeurReal(valeur);
     EditValeur.text := affVoltmetre+' '+nomUniteAff;
     except
         Gauge.position := 0
     end;
end end;

procedure TOrphyLabDlg.OKBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     with graphe.voieOrphy[voieCourante] do begin
          Nom := EditNom.text;
          NomUnite := EditUnite.text;
          Signif := EditComment.text;
          Couleur := CouleurCombo.selected;
          Motif := Tmotif(PointCombo.itemIndex);
          filtrage50Hz := filtreCB.checked;
           if FormatFixeCB.checked
             then NbreDecimaleFixe := NbreDecimaleSE.value
             else NbreDecimaleSE.value := -1;
          if Capsule.casParticulier<>cOxymetre then
          if useBis or calibreBis
              then begin
                 signif := capsule.signifCbis;
                 titre := capsule.titreCbis;
                 capteur := capsule.capteurCbis
              end
              else begin
                 signif := capsule.SignifC;
                 titre := capsule.titreC;
                 capteur := capsule.capteurC
              end;
    end;
end;

procedure TOrphyLabDlg.EtalonneBtnClick(Sender: TObject);
begin with graphe.voieOrphy[voieCourante] do begin
   if Capsule.nomUniteC='V' then begin
     timer.enabled := false;
     if ListeCapteursVoltDlg=nil then
        Application.CreateForm(TListeCapteursVoltDlg, ListeCapteursVoltDlg);
     if ListeCapteursVoltDlg.showModal=mrOK then begin
        FormActivate(nil);
        modif := true;
     end;
     timer.enabled := true;
     exit;
   end;
   if EtalonnageFait
       then begin if OKReg(trDelEtalon) then
           with capsule do begin
              modif := true;
              setMinMax(valeur0,valeur1024);
              EtalonnageFait := false;
              EditUnite.text := 'V';
          end;
       end
       else begin
          Nom := EditNom.text;
          NomUnite := EditUnite.text;
          if EtalonneInterDlg=nil then application.createForm(TEtalonneInterDlg,EtalonneInterDlg);
          EtalonneInterDlg.EditSignif.text := signif;
          EtalonneInterDlg.voieCourante := voieCourante;
          EtalonneInterDlg.showModal;
          modif := true;
   end;
   SetEtalonnage;
end end;

procedure TOrphyLabDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_VoiesAnalogiques)
end;

procedure TOrphyLabDlg.NbreDecimaleSEChange(Sender: TObject);
begin
   graphe.voieOrphy[voieCourante].NbreDecimaleFixe := NbreDecimaleSE.value
end;

procedure TOrphyLabDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not caracNom(key) then key := #0
end;

procedure TOrphyLabDlg.CalibreRGClick(Sender: TObject);
begin with graphe.voieOrphy[voieCourante] do begin
      EtalonnageFait := false;
      useBis := (CalibreRG.itemIndex=1) and
                capsule.doubleCalibre;
      setEtalonnage;
  with capsule do begin
      if useBis
         then begin
             Signif := signifCBis;
             titre := titreCbis;
             capteur := capteurCbis;
             setMinMax(Valeur0Bis,valeur1024Bis);
         end
         else begin
             Signif := signifC;
             titre := titreC;
             capteur := capteurC;
             setMinMax(Valeur0,valeur1024);
         end;
   end;
end end;

procedure TOrphyLabDlg.CapsuleBtnClick(Sender: TObject);
begin
    if CapsuleCfgDlg=nil then
       application.createForm(TCapsuleCfgDlg,CapsuleCfgDlg);
    CapsuleCfgDlg.voieCourante := graphe.voieOrphy[voieCourante];
    CapsuleCfgDlg.showModal;
    modif := true;
end;

procedure TOrphyLabDlg.CalibreCO2Click(Sender: TObject);
begin with graphe.voieOrphy[voieCourante],capsule do begin
      calibreBis := (CalibreRG.itemIndex=1);
      if calibreBis
         then begin
             Signif := signifCBis;
             titre := capsule.titreCbis;
             capteur := capsule.capteurCbis;
             setMinMax(Valeur0Bis,valeur1024Bis);
         end
         else begin
             Signif := signifC;
             titre := capsule.titreC;
             capteur := capsule.capteurC;
             setMinMax(Valeur0,valeur1024);
         end;
end end;

procedure TOrphyLabDlg.ZeroBtnClick(Sender: TObject);
begin
   if ZeroDlg=nil then application.createForm(TZeroDlg,ZeroDlg);
   ZeroDlg.voie := voieCourante;
   ZeroDlg.showModal
end;

procedure TOrphyLabDlg.CalibreO2Click(Sender: TObject);
begin with graphe.voieOrphy[voieCourante] do begin
      if CalibreRG.itemIndex=1
         then begin
             setMinMax(0,15);
             nomUnite := 'mg/L';
             nomUniteAff := 'mg/L';
         end
         else begin
             nomUnite := '%';
             nomUniteAff := '%';
             setMinMax(0,maxiOxymetrePc);
             maxi := 21;
         end;
     editUnite.text := nomUnite;
     calculMinMax;
end end;

end.

