unit OrphyLabFreqU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Gauges, Grids,
  orphyLabUtil, orphyLabDef, orphyLabGraphe, orphyLabMainU, maths,
  etalon, orphyLabConst, ImgList, ComCtrls, aidekey;

type
  TOrphyFrequenceDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    CouleurCombo: TColorBox;
    PageControl1: TPageControl;
    frequenceTS: TTabSheet;
    TempsTS: TTabSheet;
    GrandeurGB: TGroupBox;
    Label1: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    EditNom: TEdit;
    EditMax: TEdit;
    EditSignif: TEdit;
    EditMin: TEdit;
    ModeRG: TRadioGroup;
    MontantRG: TRadioGroup;
    PointCombo: TComboBoxEx;
    UniteRG: TRadioGroup;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure ModeRGClick(Sender: TObject);
  private
  public
    voieCourante : IndiceVoie;
    modif : boolean;
  end;

var
  OrphyFrequenceDlg: TOrphyFrequenceDlg;

implementation

uses zeroU;

{$R *.DFM}

procedure TOrphyFrequenceDlg.FormActivate(Sender: TObject);
begin
    with graphe.voieOrphy[voieCourante] do begin
          if (Nom[1]='U') then Nom[1] := 'f';
          EditNom.text := Nom;
          UniteRG.itemIndex := ord(OrphyLabMain.FreqTourMin);
          EditSignif.text := signif;
          EditMax.text := FormatPortable(OrphyLabMain.FreqMax);
          EditMin.text := FormatPortable(OrphyLabMain.FreqMin);
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          montantRG.ItemIndex := Ord(graphe.montant);
          if ModeAcq=AcqTemps
             then begin
                pageControl1.ActivePage := tempsTS;
                modeRG.itemIndex := ord(utilisationEF);
             end
             else begin
                pageControl1.ActivePage := frequenceTS;
                modeRG.itemIndex := 1;
             end;
          modif := false;
    end;
end;

procedure TOrphyFrequenceDlg.OKBtnClick(Sender: TObject);
begin
     with graphe.voieOrphy[voieCourante] do begin
          Nom := EditNom.text;
          Signif := EditSignif.text;
          Couleur := CouleurCombo.selected;
          Motif := Tmotif(PointCombo.itemIndex);
          modif := modif or (ord(utilisationEF)<>modeRG.itemIndex);
          utilisationEF := TutilisationEF(modeRG.itemIndex);
          graphe.montant := boolean(montantRG.ItemIndex);
          case utilisationEF of
             fFrequence : begin
             if not (modeAcq in [AcqTemps,AcqPoint,AcqClavier]) then modeAcq := AcqPoint;
             OrphyLabMain.FreqTourMin := UniteRG.itemIndex>0;
             modeSynchro := s_clavier;
             if UniteRG.itemIndex=0
                then begin
                   modif := modif or (nomUnite<>'Hz');
                   NomUnite := 'Hz';
                end
                else begin
                   modif := modif or (nomUnite<>'tr/min');
                   NomUnite := 'tr/min';
                end;
             OrphyLabMain.FreqMax := StrToFloatWin(EditMax.text);
             OrphyLabMain.FreqMin := StrToFloatWin(EditMin.text);
             setMinMax(0,OrphyLabMain.FreqMax);
            end;
            fSynchro : begin
                modeAcq := AcqTemps;
                if (Capsule.casParticulier=cSynchro) then
                  modeSynchro := s_front;
            end;
          end;
    end;
end;

procedure TOrphyFrequenceDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext( HELP_MesureFrequence)
end;

procedure TOrphyFrequenceDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not caracNom(key) then key := #0
end;

procedure TOrphyFrequenceDlg.ModeRGClick(Sender: TObject);
begin
      if ModeRG.itemIndex=1
           then pageControl1.ActivePage := frequenceTS
           else pageControl1.ActivePage := tempsTS;
end;

end.

