unit OrphyLabReg;

interface

uses Windows, Classes, Graphics, Forms, Buttons,
  StdCtrls, ExtCtrls, SysUtils, iniFiles, dialogs, Grids,
  math, Controls,
  maths, orphyLabUtil, orphyLabDef, orphyLabGraphe, aidekey;

type
  TConstanteDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    NewPageCB: TRadioGroup;
    GroupBox2: TGroupBox;
    UniteL1: TLabel;
    NomConstEdit: TEdit;
    Label1: TLabel;
    UniteConstEdit: TEdit;
    Label2: TLabel;
    ValeurConstEdit: TEdit;
    FileRegCB: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FileRegCBClick(Sender: TObject);
  private
  public
      nomConstante : string;
      uniteConstante : string;
      valeurConstante : double;
  end;

var
  ConstanteDlg: TConstanteDlg;

implementation

{$R *.DFM}

procedure TConstanteDlg.OKBtnClick(Sender: TObject);
begin
        nomConstante := nomConstEdit.text;
        uniteConstante := uniteConstEdit.text;
        try
        valeurConstante := StrToFloatWin(valeurConstEdit.text);
        except
        valeurConstante := Nan;
        end;
end;

procedure TConstanteDlg.FileRegCBClick(Sender: TObject);
begin
  newPageCB.Visible := not fileRegCB.Checked;
end;

procedure TConstanteDlg.FormActivate(Sender: TObject);
begin
      nomConstEdit.text := nomConstante;
      uniteConstEdit.text := uniteConstante;
      valeurConstEdit.text := FormatPortable(ValeurConstante);
      FileRegCB.visible := remanence and (graphe.nbrePages>1) and (newPageCB.items.Count=2);
      if not FileRegCB.visible then FileRegCB.checked := false;
      newPageCB.Visible := not fileRegCB.Checked;
end;

procedure TConstanteDlg.FormCreate(Sender: TObject);
var Fichier : tMemIniFile;
begin
      nomConstante := '';
      uniteConstante := '';
      valeurConstante := Nan;
      if FileExists(nomFichierConfig) then begin
         Fichier := tMemIniFile.create(NomFichierConfig);
         with Fichier do begin
              nomConstante := readString('Constante','Nom','');
              uniteConstante := readString('Constante','Unite','');
              editComm.text := readString('Constante','Commm','');
        end;
        fichier.free;
     end;
end;

procedure TConstanteDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_Regressi)
end;

end.
