unit SortieAna_comp;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, spin, StdCtrls, Buttons, inifiles,
  parser10, oomisc, AdPort,
  maths, uniteker,
  orphyLabDef, orphyLabUtil;

const
      NbreMaxGBF = 2000;
      MaxiGBF = 4095; // 12 bits
      ZeroGBF = 2048; // la moiti
      TensionMaxGBF = 5;
    //  Le GBF a comme gamme +-TensionMaxGBF=+-5 V
      FreqMaxGBF = 5e3; // 20 points   10 s
      FreqMinGBF = 0.02; // 2000 points  65 ms = 130 s = 8 mHz
      StopSA = #121; // y
      setSA = #120; // x
      LanceSA = #119;  // w
      ParamSA = #118; // v
      FreqHorloge = 1e6;
      FreloadMin = 10;

type
  indiceVecteurGBF = 0..NbreMaxGBF;
  TvecteurGBF = array[indiceVecteurGBF] of integer;

  TSA = class
     private
     ParserI : Tparser;
     FreloadGBF : integer; // Periode unit s
     FfreqGBF : double; // frquence relle
     FNbreGBF : integer; // nombre donnes du tableau
     data : TvecteurGBF;
     procedure setFreqGBF(afreq : double);
     procedure setValeur(avalue : double);
     Procedure setExpression(avalue : string);
     Function getExpression : string;
     public
     Amplitude,Offset : double;
     signal  : Tsignal;
     voieSerie : TapdComport;
     expressionCorrecte : boolean;
     valeurCouranteInt : integer;
     property expression : string read getExpression write setExpression;
     Procedure CalculValeur;
     procedure Paint(Acanvas : Tcanvas;largeur,hauteur : integer);
     property NbreGBF : integer read FNbreGBF;
     property FreqGBF : double read FFreqGBF write setFreqGBF;
     property valeur : double write setValeur;
     procedure setSATrack(valeurI : integer;var valeurR : double);
     procedure setSATime(t: double;var valeurR : double); // t entre 0 et 1
     procedure ProgrammeGBF;
     function valeurInt(valeurR : double) : integer;
     function valeurReal(valeurI : integer) : double;
     constructor Create;
     destructor Destroy;override;
  end;

var SortieAnalogique : TSA;

implementation

function TSA.valeurInt(valeurR : double) : integer;
// $0FFF=maxiGBF=4095 correspond  +5 V
// $0800=zeroGBF=2048 correspond a 0 V
// 0 correspond  -5 V
begin
     result := round(valeurR*MaxiGBF/2/TensionMaxGBF)+zeroGBF;
     if result<0 then result := 0;
     if result>MaxiGBF then result := maxiGBF;
end;

function TSA.valeurReal(valeurI : integer) : double;
begin
     result := valeurI*2*tensionMaxGBF/MaxiGBF-tensionMaxGBF
end;

Procedure TSA.CalculValeur;
var valeurR,deltat,pente : double;
    posDuty,i : integer;
begin
     deltat := 1/FnbreGBF;
     case signal of
        sSinus : begin
            if (amplitude+offset)>TensionMaxGBF then
               offset := TensionMaxGBF-Amplitude;
            if (-amplitude+offset)<-TensionMaxGBF then
               offset := -TensionMaxGBF+Amplitude;
            for i := 0 to pred(FnbreGBF) do begin
               valeurR := Amplitude*sin(2*pi*i*deltat);
               data[i] := valeurInt(valeurR+Offset);
            end;
        end;
        sArbitraire : if expressionCorrecte
           then for i := 0 to pred(FNbreGBF) do begin
                 ParserI.T := i*deltat;
                 valeurR := ParserI.Value;
                 data[i] := valeurInt(valeurR);
           end
           else for i := 0 to pred(FNbreGBF) do
                 data[i] := valeurInt(0);
        sContinu : begin
            FnbreGBF := 64;
            FreloadGBF := 32764;
            for i := 0 to pred(FnbreGBF) do
               data[i] := valeurInt(Offset);
        end;
        else begin
          if (amplitude+offset)>TensionMaxGBF then
             offset := TensionMaxGBF-Amplitude;
          if (-amplitude+offset)<-TensionMaxGBF then
             offset := -TensionMaxGBF+Amplitude;
          PosDuty := FnbreGBF div 2;
          if posDuty<2 then posDuty := 2;
          if posDuty>(FnbreGBF-2) then posDuty := FnbreGBF-2;
          pente := Amplitude*2.0/posDuty;
          for i := 0 to posDuty do begin
              if signal=sCarre
                 then valeurR := Amplitude
                 else valeurR := -Amplitude+i*pente;
              data[i] := valeurInt(valeurR+Offset);
          end;
          pente := Amplitude*2.0/(FnbreGBF-posDuty);
          for i := succ(posDuty) to pred(FnbreGBF) do begin
              if signal=sCarre
                 then valeurR := -Amplitude
                 else valeurR := Amplitude-(i-posDuty)*pente;
              data[i] := valeurInt(valeurR+Offset);
          end;
        end;
     end;
     for i := FnbreGBF to NbreMaxGBF do data[i] := ZeroGBF;
end;

procedure TSA.Paint(Acanvas : Tcanvas;largeur,hauteur : integer);
var i : indiceVecteur;
    xi,yi,debut : integer;
    AX,AY : double;

Procedure GetXY;
begin
      yi := round(AY*data[i]);
      xi := round(AX*(i+debut));
      Acanvas.LineTo(xi,hauteur-yi);
end;

begin with Acanvas do begin
     brush.Style := bsSolid;
     brush.color := clWindow;
     pen.width := 1;
     pen.style := psSolid;
     pen.color := clBlack;
     rectangle(0,0,largeur,hauteur);
     pen.color := clBlue;
     AY := hauteur/maxiGBF;
     AX := largeur/FnbreGBF/(1+0.5);// 25 % avant et aprs
     if signal=sContinu then begin
        yi := round(AY*data[0]);
        xi := 0;
        Acanvas.MoveTo(xi,hauteur-yi);
        xi := largeur;
        Acanvas.LineTo(xi,hauteur-yi);
        exit;
     end;
     debut := FNbreGBF div 4;
     yi := round(AY*data[0]);
     xi := round(AX*debut);
     MoveTo(xi,hauteur-yi);
     for i := 1 to pred(FnbreGBF) do GetXY;
     debut := FnbreGBF + FNbreGBF div 4; // dbut prochaine priode
     for i := 0 to FNbreGBF div 4 do GetXY;
     debut := -3*FNbreGBF div 4; // fin priode prcdente
     yi := round(AY*data[-debut]);
     MoveTo(0,yi);
     for i := -debut to pred(FNbreGBF) do GetXY;
     debut := FNbreGBF div 4;
     yi := round(AY*data[0]);
     xi := round(AX*debut);
     LineTo(xi,hauteur-yi);
// limite de la priode
     pen.style := psDash;
     pen.color := clRed;
     xi := round(AX*FNbreGBF/4);
     MoveTo(xi,0);
     LineTo(xi,hauteur);
     xi := round(5*AX*FNbreGBF/4);
     MoveTo(xi,0);
     LineTo(xi,hauteur);
// zro
     yi := hauteur div 2;
     pen.style := psDot;
     pen.color := clBlack;
     MoveTo(0,yi);
     LineTo(largeur,yi);
     if FfreqGBF<1 then begin
        pen.width := 2;
        pen.style := psSolid;
        pen.color := clGreen;
        yi := hauteur div 5;
        xi := round(AX*(FNbreGBF div 4));
        MoveTo(xi,yi);
        xi := round(AX*(5*FNbreGBF div 4));
        LineTo(xi,yi);
        xi := round(AX*(3*FNbreGBF div 4));
        yi := hauteur div 20;
        TextOut(xi,yi,FormatTimeCourt(1/FfreqGBF)+' s');
     end;
end end;
                                                    
procedure TSA.ProgrammeGBF;
var i,attente : integer;
    Timer: EventTimer;
begin
    VoieSerie.OutPut := StopSA;
    sleep(20);
    if signal=sContinu then begin
        setValeur(offset);
        sleep(10);
        exit;
    end;
    VoieSerie.OutPut := ParamSA;
    VoieSerie.Output := #0; // non monocoup
    VoieSerie.OutPut := codeValeur2(FreloadGBF);
    VoieSerie.OutPut := codeValeur2(FnbreGBF);
    sleep(20);
    newTimer(timer, 2);
    repeat
    until (voieSerie.OutBuffUsed=0) or timerExpired(timer);
    for i := 0 to pred(FNbreGBF) do
        VoieSerie.OutPut := codeValeur2(Data[i]);
    attente := 18*FnbreGBF div 2000; // 0,6 s pour 2000 points major  18 ticks (1 s)
    if attente<6 then attente := 6;
    newTimer(timer, attente);
// attente X 
    repeat
        voieSerie.processCommunications;
    until voieSerie.charReady or timerExpired(timer);
    if voieSerie.charReady then voieSerie.getChar; // lecture de X
    sleep(10);
end;

procedure TSA.setFreqGBF(afreq : double);
var Nbre : longInt;
begin
    if afreq<FreqMinGBF then afreq := freqMinGBF;
    if afreq>FreqMaxGBF then afreq := freqMaxGBF; 
    Nbre := round(freqHorloge/afreq);
    FReloadGBF := (Nbre div NbreMaxGBF) + 1;
    if FreloadGBF<FreloadMin then FreloadGBF := FreloadMin;
    FNbreGBF := Nbre div FreloadGBF;
    FfreqGBF := freqHorloge/FNbreGBF/FReloadGBF;
end;

constructor TSA.Create;
begin
     inherited create;
     signal := sSinus;
     freqGBF := 1000;
     Amplitude := 2;
     Offset := 0;
     ParserI := Tparser.create(nil);
     ParserI.expression := 't*5';
     expressionCorrecte := true;
end;

procedure TSA.setValeur(avalue : double);
begin
     valeurCouranteInt := valeurInt(avalue);
     VoieSerie.OutPut := setSA+codeValeur2(valeurCouranteInt);
end;

procedure TSA.SetExpression(avalue : string);
begin
     if ParserI.expression<>avalue then begin
         expressionCorrecte := true;
         try
         ParserI.expression := avalue
         except
         on E: EMathParserError do begin
            expressionCorrecte := false;
            showMessage(E.Message);
         end;
         end;
    end;
end;

function TSA.getExpression : string;
begin
     if expressionCorrecte
        then result := ParserI.expression
        else result := 'Entrez une fonction de t'
end;

destructor TSA.Destroy;
begin
    parserI.free;
    inherited destroy;
end;

procedure TSA.setSATime(t: double;var valeurR : double);
begin
      ParserI.T := t;
      valeurR := ParserI.Value;
      setValeur(valeurR)
end;

procedure TSA.setSAtrack(valeurI: integer;var valeurR : double);
begin
   valeurR := valeurReal(valeurI);
   setValeur(valeurR);
end;

initialization
  SortieAnalogique := TSA.create;

finalization
  SortieAnalogique.Free;

end.


