unit UICfg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils,Gauges, Grids,
  orphyLabUtil, orphyLabDef, orphyLabGraphe, orphyLabMainU, maths,
  orphyLabConst, ImgList, ComCtrls, aidekey;

type
  TUIcfgDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    Label1: TLabel;
    HelpBtn: TBitBtn;
    Label3: TLabel;
    EditComment: TEdit;
    ZeroGB: TGroupBox;
    MemoAutre: TMemo;
    ZeroBtn: TBitBtn;
    Zero0Btn: TBitBtn;
    CapteursBtn: TBitBtn;
    Timer: TTimer;
    Gauge: TProgressBar;
    EditValeur: TEdit;
    EditUnite: TEdit;
    Label2: TLabel;
    EtalonneBtn: TBitBtn;
    VoltBtn: TBitBtn;
    GroupBox1: TGroupBox;
    PositifCB: TCheckBox;
    MaxiEdit: TLabeledEdit;
    CouleurCombo: TColorBox;
    NbreDecimaleLabel: TLabel;
    NbreDecimaleSE: TSpinEdit;
    FormatFixeCB: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure ZeroBtnClick(Sender: TObject);
    procedure Zero0BtnClick(Sender: TObject);
    procedure CapteursBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure EtalonneBtnClick(Sender: TObject);
    procedure VoltBtnClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormatFixeCBClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
    voieCourante : IndiceVoie;
  end;

var
  UIcfgDlg: TUIcfgDlg;

implementation

uses LISTECAPvolt, ETALON6V;

{$R *.DFM}

procedure TUIcfgDlg.FormActivate(Sender: TObject);
begin
    with graphe.voieOrphy[voieCourante] do begin
         EditNom.text := Nom;
         EditComment.text := Signif;
         EditUnite.text := NomUnite;
         CouleurCombo.selected := couleur;
         caption := 'Entres fiches bananes OrphyLab : '+NomFB[voieCourante];
         case NumeroOrphy of
           8,9,10 : VoltBtn.caption := 'Voltmtre';
           11 : VoltBtn.caption := 'Voltmtre';
           12,13,14 : VoltBtn.caption := 'Ampremtre';
           15 : VoltBtn.caption := 'Ampremtre';
         end;
         positifCB.Checked := positif;
         MaxiEdit.text := FormatPortable(Maxi);
         VoltBtn.Visible := numeroOrphy in [8,9,10,11];
         CapteursBtn.Visible := VoltBtn.Visible;
         formatFixeCB.Checked := NbreDecimaleFixe>=0;
         NbreDecimaleSE.value := NbreDecimaleFixe;
         NbreDecimaleSE.Visible := FormatFixeCB.checked;
         NbreDecimaleLabel.visible := FormatFixeCB.checked;
    end;
    timer.Enabled := true;
end;

procedure TUIcfgDlg.FormatFixeCBClick(Sender: TObject);
begin
  NbreDecimaleSE.Visible := FormatFixeCB.checked;
  NbreDecimaleLabel.visible := FormatFixeCB.checked;
end;

procedure TUIcfgDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    timer.Enabled := false;
end;

procedure TUIcfgDlg.FormDeactivate(Sender: TObject);
begin
      timer.Enabled := false;
end;

procedure TUIcfgDlg.OKBtnClick(Sender: TObject);
begin
    timer.Enabled := false;
    with graphe.voieOrphy[voieCourante] do begin
          Nom := EditNom.text;
          Signif := EditComment.text;
          NomUnite := EditUnite.text;
          Couleur := CouleurCombo.selected;
          try
          maxi := StrToFloatWin(maxiEdit.text);
          except
          end;
          positif := positifCB.Checked;
          if positif then mini := 0 else mini := -maxi;
          if FormatFixeCB.checked
             then NbreDecimaleFixe := NbreDecimaleSE.value
             else NbreDecimaleSE.value := -1
    end;
end;

procedure TUIcfgDlg.TimerTimer(Sender: TObject);
var valeur : word;
begin with graphe.voieOrphy[voieCourante] do begin
     try
     valeur := OrphyLabMain.getWord(ZEA);
     Gauge.position := valeur;
     valeurAff := valeurReal(valeur);
     EditValeur.text := affVoltmetre+' '+nomUniteAff;
     except
         Gauge.position := 0
     end;
end end;

procedure TUIcfgDlg.VoltBtnClick(Sender: TObject);
begin with graphe.voieOrphy[voieCourante] do begin
    case NumeroOrphy of
         8,9,10 : begin
             nomUnite := 'V';
             capteur := 'Voltmtre';
             maxiCapteur := 25;
         end;
         11 : begin
             nomUnite := 'V';
             capteur := 'Voltmtre';
             maxiCapteur := 6;
         end;
         12,13,14 : begin
             nomUnite := 'A';
             capteur := 'Ampremtre';
             maxiCapteur := 0.25;
         end;
         15 : begin
             nomUnite := 'A';
             capteur := 'Ampremtre';
             maxiCapteur := 1;
         end;
    end;
    setMinMax(-maxiCapteur,maxiCapteur);
    maxi := maxiCapteur;
    if positifCB.checked
       then mini := 0
       else mini := -maxi;
    FormActivate(nil);
end end;

procedure TUIcfgDlg.ZeroBtnClick(Sender: TObject);
var val0,valeur0 : integer;
begin with graphe.voieOrphy[voieCourante] do begin
    Valeur0 := OrphyLabMain.GetWord(ZEA);
    val0 := valeurInt(0);
    offset := val0-valeur0;
end end;

procedure TUIcfgDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Configuration)
end;

procedure TUIcfgDlg.Zero0BtnClick(Sender: TObject);
begin
     graphe.voieOrphy[voieCourante].offset := 0
end;

procedure TUIcfgDlg.CapteursBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     if ListeCapteursVoltDlg=nil then
        Application.CreateForm(TListeCapteursVoltDlg, ListeCapteursVoltDlg);
     ListeCapteursVoltDlg.voieCourante := voieCourante;
     if ListeCapteursVoltDlg.showModal=mrOK then
        FormActivate(nil);
     timer.enabled := true;
end;

procedure TUIcfgDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not caracNom(key) then key := #0
end;

procedure TUIcfgDlg.EtalonneBtnClick(Sender: TObject);
begin with graphe.voieOrphy[voieCourante] do begin
    timer.Enabled := false;
    if Etalonne6VDlg=nil then
       application.createForm(TEtalonne6VDlg,Etalonne6VDlg);
    Etalonne6VDlg.voieCourante := voieCourante;
    if Etalonne6VDlg.showModal=mrOK then calculMinMax;
    timer.Enabled := true;
end end;

end.

