unit capteurCfgU;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, Tabs,
  Buttons, ExtCtrls, sysutils,
  orphyLabDef, orphyLabUtil, ComCtrls, Spin, orphyLabConst, aidekey;

type
  TCapteurCfgDlg = class(TForm)
    ButtonPanel: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Notebook: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GrandeurGB: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditNom: TEdit;
    EditUnite: TEdit;
    EditSignif: TEdit;
    AffichageGB: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    EditMini: TEdit;
    EditMaxi: TEdit;
    GroupBox1: TGroupBox;
    val0Edit: TEdit;
    PenteEdit: TEdit;
    Val0Label: TLabel;
    PenteLabel: TLabel;
    EditTitre: TLabeledEdit;
    EditAide: TLabeledEdit;
    NbreDecimaleLabel: TLabel;
    NbreDecimaleSE: TSpinEdit;
    FormatFixeCB: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormatFixeCBClick(Sender: TObject);
  private
  public
    CapteurCourant : TCapteur;
  end;

var
  CapteurCfgDlg: TCapteurCfgDlg;

implementation

{$R *.DFM}

procedure TCapteurCfgDlg.FormActivate(Sender: TObject);
begin with capteurCourant do begin
     EditSignif.text := signifC;
     EditAide.text := aideC;
     EditTitre.text := titreC;
     EditNom.text := nomC;
     EditUnite.text := nomUniteC;
     val0Edit.text := FormatPortable(zeroVoltC);
     penteEdit.text := FormatPortable(unVoltC);
     penteLabel.caption := DeltaMaj+nomC+'/'+DeltaMaj+'U'+
         ' ('+nomUniteC+'/V)';
     EditMini.text := FormatPortable(miniC);
     EditMaxi.text := FormatPortable(maxiC);
     formatFixeCB.Checked := NbreDecimaleC>=0;
     NbreDecimaleSE.value := NbreDecimaleC;
     NbreDecimaleSE.Visible := FormatFixeCB.checked;
     NbreDecimaleLabel.visible := FormatFixeCB.checked;
end end;

procedure TCapteurCfgDlg.FormatFixeCBClick(Sender: TObject);
begin
  NbreDecimaleSE.Visible := FormatFixeCB.checked;
  NbreDecimaleLabel.visible := FormatFixeCB.checked;
end;

procedure TCapteurCfgDlg.EditNomChange(Sender: TObject);
begin
     PenteLabel.caption := DeltaMaj+EditNom.text+'/'+DeltaMaj+'U'+
        ' ('+EditUnite.text+'/V)';
     AffichageGB.caption := trAffichage+EditUnite.text+')';
end;

procedure TCapteurCfgDlg.OKBtnClick(Sender: TObject);
begin with capteurCourant do begin
     signifC := EditSignif.text;
     aideC := EditAide.text;
     titreC := EditTitre.text;
     nomC := EditNom.text;
     nomUniteC := EditUnite.text;
     zeroVoltC := strToFloatWin(val0Edit.text);
     UnVoltC := strToFloatWin(penteEdit.text);
     if FormatFixeCB.checked
        then NbreDecimaleC := NbreDecimaleSE.value
        else NbreDecimaleC := -1;
     try
     miniC := strToFloatWin(EditMini.text);
     except
     end;
     try
     maxiC := strToFloatWin(EditMaxi.text);
     except
     end;
end end;

procedure TCapteurCfgDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_ConfigurationCapteurs)
end;

end.

