unit lecttext;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls, sysUtils,  ComCtrls,
  system.UITypes,
  Messages, Dialogs, ImgList, CheckLst,
  orphyLabConst, orphyLabGraphe, aidekey;

type
  TLectureTexteDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    PageControl: TPageControl;
    OptionsTab: TTabSheet;
    CadreCB: TCheckBox;
    LabelTaille: TLabel;
    SpinEditHauteur: TSpinEdit;
    CouleurCombo: TColorBox;
    OpaqueColorBox: TColorBox;
    CouleurComboLabel: TLabel;
    Edit: TMemo;
    OpaqueCB: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure OpaqueCBClick(Sender: TObject);
  private
  public
    DessinLoc : Tdessin;
  end;

var
  LectureTexteDlg: TLectureTexteDlg;

implementation

{$R *.DFM}

procedure TLectureTexteDlg.FormActivate(Sender: TObject);
begin with dessinLoc do begin
     Edit.lines.assign(texte);
     Edit.SetFocus;
     CadreCB.checked := avecCadre;
     CouleurCombo.selected := pen.color;
     SpinEditHauteur.text := IntToStr(hauteur);
     OpaqueColorBox.selected := CouleurFond;
     opaqueCB.checked := IsOpaque;
     OpaqueColorBox.visible := IsOpaque;
end end;

procedure TLectureTexteDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Texte)
end;

procedure TLectureTexteDlg.OKBtnClick(Sender: TObject);
begin with dessinLoc do begin
            pen.color := CouleurCombo.selected;
            CouleurFond := colorToRGB(OpaqueColorBox.selected);
            hauteur := StrToInt(SpinEditHauteur.text);
            texte.assign(Edit.lines);
            avecCadre := CadreCB.checked;
            IsOpaque := opaqueCB.checked;
end end;

procedure TLectureTexteDlg.OpaqueCBClick(Sender: TObject);
begin
   OpaqueColorBox.visible := OpaqueCB.checked;
end;

procedure TLectureTexteDlg.PageControlChange(Sender: TObject);
begin
     CouleurComboLabel.visible := CouleurCombo.visible;
end;

end.
