unit lumicolorU;

interface

uses Windows, Classes, Graphics, Forms, Buttons, Controls,
  StdCtrls, ExtCtrls, Sysutils, OrphyLabGraphe, ComCtrls,
  maths, orphyLabUtil, orphyLabDef, orphyLabMainU, orphyLabConst, aidekey;

type
  TlumicolorDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Timer: TTimer;
    OKbtn: TSpeedButton;
    GaugeInter1: TProgressBar;
    MemoPhoto: TMemo;
    TensionLabel: TLabel;
    AbsLabel: TLabel;
    TensionRefRG: TRadioGroup;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
  private
  public
  end;

var
  lumicolorDlg: TlumicolorDlg;

implementation

const
    valMax : array[0..1] of double = (4.6,2.2);
    valMin : array[0..1] of double = (4,1.8);

{$R *.DFM}

procedure TlumicolorDlg.TimerTimer(Sender: TObject);
var zi : word;
begin
     zi := OrphyLabMain.getWord(char(64+11));
     GaugeInter1.position := zi;
     tensionLabel.caption := 'V='+uniteVolt.formatUnite(voieCapteur6V.ValeurVolt(zi));
     voieCapteur6V.valeurAff := voieCapteur6V.valeurReal(zi);
     absLabel.caption := 'A='+voieCapteur6V.AffVoltmetre;
end;

procedure TlumicolorDlg.FormActivate(Sender: TObject);
begin
     GaugeInter1.position := 0;
     timer.enabled := true;
     GaugeInter1.Max := MaxiHard;
     voieCapteur6V.isLumicolor := true;
     if tensionRefLumicolor>3
        then tensionRefRG.ItemIndex := 0
        else tensionRefRG.ItemIndex := 1
end;

procedure TlumicolorDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TlumicolorDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TlumicolorDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_Lumicolor)
end;

procedure TlumicolorDlg.OKbtnClick(Sender: TObject);
var valeurCan : double;
begin with voieCapteur6V do begin
     try
     valeurCan := ValeurVolt(GaugeInter1.position);
     if (valeurCan>valMin[TensionRefRG.itemIndex]) and
        (valeurCan<valMax[TensionRefRG.itemIndex])
        then begin
           modalResult := mrOK;
           tensionRef := valeurCan;
           tensionRefLumicolor := tensionRef;
        end
        else begin
           afficheErreur(erPhotocolor);
           modalResult := mrNone;
        end;
     except
        modalResult := mrNone;
     end;
end end;

end.
