unit optPro;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, TabNotBk, ComCtrls, fileCtrl,
  registry, Dialogs, Mask,
  orphyLabConst, orphyLabDef, orphyLabUtil, aidekey;

type
  TOptionsDlg = class(TForm)
    Panel1: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    OpenDialog: TOpenDialog;
    MilliCB: TCheckBox;
    Label4: TLabel;
    BaudRG: TRadioGroup;
    CardiaqueSE: TSpinEdit;
    SauveNumCB: TCheckBox;
    Label2: TLabel;
    Label6: TLabel;
    RepertCfgAff: TEdit;
    RepertGTIBTN: TSpeedButton;
    GroupBox1: TGroupBox;
    ZeroCapsuleCB: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RepertGTIBTNClick(Sender: TObject);
  private
  public
  end;

var
  OptionsDlg: TOptionsDlg;

implementation

uses orphyLabMainU, OrphyLabgraphe;

{$R *.DFM}

procedure TOptionsDlg.OKBtnClick(Sender: TObject);
begin
    OrphyLabMain.ConfigPath := RepertCfgAff.text;
    OrphyLabMain.SauveNum := sauveNumCB.checked;
    avecExposant := MilliCB.checked;
    ZeroCapsulePermis := ZeroCapsuleCB.checked;
    NbreMoyCardiaque := cardiaqueSE.value;
    codeBaud := baudRG.itemIndex;
end;

procedure TOptionsDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Options)
end;

procedure TOptionsDlg.FormActivate(Sender: TObject);
begin
    repertCfgAff.text := OrphyLabMain.ConfigPath;
    sauveNumCB.checked := OrphyLabMain.SauveNum;
    MilliCB.checked := avecExposant;
    ZeroCapsuleCB.checked := ZeroCapsulePermis;
    cardiaqueSE.MaxValue := MaxMoyCardiaque;
    cardiaqueSE.MinValue := MaxMoyCardiaque div 10;
    cardiaqueSE.value := NbreMoyCardiaque;
    baudRG.itemIndex := codeBaud;
    baudRG.Visible := isOrphyLab;
end;


procedure TOptionsDlg.RepertGTIBTNClick(Sender: TObject);
var repertoire : string;
begin
   repertoire := OrphyLabMain.ConfigPath;
   if SelectDirectory('Rpertoire *.mo2','',repertoire) then
        RepertCfgAff.text := repertoire
end;

end.
