unit photocolorU;
interface

uses Windows, Classes, Graphics, Forms, Buttons,
  StdCtrls, ExtCtrls, Sysutils, OrphyLabGraphe, ComCtrls,
  maths, orphyLabUtil, orphyLabDef, orphyLabMainU, orphyLabConst, Controls, aidekey;

type
  TphotocolorDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Timer: TTimer;
    OKbtn: TSpeedButton;
    GaugeInter1: TProgressBar;
    MemoPhoto: TMemo;
    TensionLabel: TLabel;
    AbsLabel: TLabel;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
  private
  public
  end;

var
  photocolorDlg: TphotocolorDlg;

implementation

{$R *.DFM}

procedure TphotocolorDlg.TimerTimer(Sender: TObject);
var zi : word;
begin
     zi := OrphyLabMain.getWord(char(64+11));
     GaugeInter1.position := zi;
     tensionLabel.caption := 'V='+uniteVolt.formatUnite(voieCapteur6V.ValeurVolt(zi));
     voieCapteur6V.valeurAff := voieCapteur6V.valeurReal(zi);
     absLabel.caption := 'A='+voieCapteur6V.AffVoltmetre;
end;

procedure TphotocolorDlg.FormActivate(Sender: TObject);
begin
     GaugeInter1.position := 0;
     timer.enabled := true;
     GaugeInter1.Max := MaxiHard;
     voieCapteur6V.isLumicolor := true;
end;

procedure TphotocolorDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TphotocolorDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TphotocolorDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_Lumicolor)
end;

procedure TphotocolorDlg.OKbtnClick(Sender: TObject);
var valeurCan : double;
begin with voieCapteur6V do begin
     try
     valeurCan := ValeurVolt(GaugeInter1.position);
     if (valeurCan>0.05) and (valeurCan<5)
        then begin
           modalResult := mrOK;
           tensionRef := valeurCan;
           tensionRefPhotocolor := tensionRef;
        end
        else begin
           afficheErreur(erPhotocolor);
           modalResult := mrNone;
        end;
     except
        modalResult := mrNone;
     end;
end end;

end.
