unit synchroU;

interface

uses SysUtils, Windows, Classes, Graphics, Forms, Controls, Buttons,
   StdCtrls, Spin, ExtCtrls, ComCtrls,
   maths, uniteker, orphyLabUtil,
   orphyLabDef, orphyLabGraphe, orphyLabMainU, orphyLabConst;

type
   TSynchroDlg = class(TForm)
    OKBtn:           TBitBtn;
    CancelBtn:       TBitBtn;
    Panel1:          TPanel;
    voieSynchroRG: TRadioGroup;
    synchroRG: TRadioGroup;
    seuilGB: TGroupBox;
    SpeedButton1: TSpeedButton;
    LabelSeuil: TLabel;
    seuilScroll: TScrollBar;
    montantRG: TRadioGroup;
    preAcqCB: TCheckBox;
    LoupeCB: TCheckBox;
    ClavierRG: TRadioGroup;
      procedure OKBtnClick(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure SynchroRGClick(Sender: TObject);
      procedure RazSeuilBtnClick(Sender: TObject);
      procedure SeuilScrollChange(Sender: TObject);
    procedure VoieSynchroRGClick(Sender: TObject);
   private
      NumVoie : array[0..3] of integer;
      procedure MajSeuil;
   public
      modif: boolean;
   end;

var
   SynchroDlg: TSynchroDlg;

implementation

{$R *.DFM}

procedure TSynchroDlg.OKBtnClick(Sender: TObject);
begin with graphe do begin
      LoupeAuto := loupeCB.Checked;
      montant := boolean(montantRG.ItemIndex);
      valeurSynchro := SeuilScroll.Position;
      if (voieSynchroRG.ItemIndex>=0) and
         (voieSynchroRG.ItemIndex<=3) then
             voieSynchro := NumVoie[voieSynchroRG.ItemIndex];
      preTrig := preAcqCB.checked;
      boutonObligatoire := clavierRG.ItemIndex>0;
end end;

procedure TSynchroDlg.FormActivate(Sender: TObject);
var voie: integer;
begin with graphe do begin
      loupeCB.Checked := LoupeAuto;
      montantRG.ItemIndex := Ord(montant);
      synchroRG.Visible := (modeSynchro in [s_clavier, s_relaxe, s_seuil]) and
         not CapsuleStimul;
      if synchroRG.Visible then begin
         synchroRG.ItemIndex := Ord(modeSynchro);
      end;
      MontantRG.Visible := modeSynchro in [s_front, s_seuil];
      if modeSynchro = s_front
         then MontantRG.Caption := '&Front'
         else MontantRG.Caption := '&Sens';
      seuilGB.Visible := modeSynchro = s_seuil;
      voieSynchroRG.Visible := modeSynchro = s_seuil;
      Modif := False;
      preAcqCB.checked := preTrig;
      SeuilScroll.Position := valeurSynchro;
      VoieSynchroRG.Items.Clear;
      for voie := 0 to 3 do
          NumVoie[voie] := voieT;
      for voie := voie0 to voieAnaMax do
         with voieOrphy[voie] do
            if active then begin
               NumVoie[VoieSynchroRG.items.count] := voie;
               VoieSynchroRG.items.add(nom);
               if voie=voieSynchro then
                  voieSynchroRG.ItemIndex := voieSynchroRG.items.count-1;
               if voieSynchroRG.items.count=4 then break;
            end;
      if voieSynchroRG.itemIndex<0 then
         voieSynchroRG.ItemIndex := 0;
      clavierRG.ItemIndex := ord(boutonObligatoire);
      majSeuil;
end end;

procedure TSynchroDlg.SeuilScrollChange(Sender: TObject);
begin
   MajSeuil;
end;

procedure TSynchroDlg.SynchroRGClick(Sender: TObject);
begin
   modeSynchro := TmodeSynchro(synchroRG.ItemIndex);
   montantRG.Visible := modeSynchro = s_seuil;
   seuilGB.Visible := modeSynchro = s_seuil;
   preAcqCB.Visible := modeSynchro = s_seuil;
   voieSynchroRG.Visible := modeSynchro = s_seuil;
   modif := true;
end;

procedure TSynchroDlg.VoieSynchroRGClick(Sender: TObject);
begin
     graphe.voieSynchro := NumVoie[voieSynchroRG.ItemIndex];
     modif := true;
     majSeuil;
end;

procedure TSynchroDlg.RazSeuilBtnClick(Sender: TObject);
begin
   SeuilScroll.Position := 2048;
end;

procedure TSynchroDlg.MajSeuil;
begin
   with graphe.voieOrphy[graphe.voieSynchro] do
      LabelSeuil.Caption := formatUnite(valeurReal(SeuilScroll.position));
end;

end.

